<?php
class MY_Input extends CI_Input{

    function MY_Input()
    {
        parent::CI_Input();
    }


    /**
     * Fetch an item from the POST array
     *
     * @access    public
     * @param    string
     * @param    bool
     * @return    string
     */
    function post($index = '', $xss_clean = FALSE)
    {        
        $value  = $this->brackets_to_index($index , "post");
        
        if ( ! isset($value))
        {
            return FALSE;
        }

        if ($xss_clean === TRUE)
        {
            if (is_array($value))
            {
                foreach($value as $key => $val)
                {                    
                    $value[$key] = $this->xss_clean($val);
                }
            }
            else
            {
                return $this->xss_clean($value);
            }
        }

        return $value;
    }
    
    // --------------------------------------------------------------------
    
    /**
     * Fetch an item from the COOKIE array
     *
     * @access    public
     * @param    string
     * @param    bool
     * @return    string
     */
    function cookie($index = '', $xss_clean = FALSE)
    {
        $value  = $this->brackets_to_index($index , "cookie");

        if ( ! isset($value))
        {
            return FALSE;
        }

        if ($xss_clean === TRUE)
        {
            if (is_array($value))
            {
                $cookie = array();
                foreach($value as $key => $val)
                {
                    $cookie[$key] = $this->xss_clean($val);
                }
        
                return $cookie;
            }
            else
            {
                return $this->xss_clean($value);
            }
        }
        else
        {
            return $value;
        }
    }    
    
    /*
     * This function gets the value of an "array item" passed via post, get or cookie which is written on the form
     * array[array1][array2][item]
     * @access    public
     * @param    string the form of the array
     * @param    string the method used to send the variable possible values are: "post" , "get" and "cookie" .. default is "post"
     * @return    string
     */
    
    function brackets_to_index($str , $method="post"){
    
        // first we remove the closing bracket ]
        $str2 = str_replace("]" , "" , $str);
        // next , we explode the str by opening bracket [
        $array = explode("[", $str2);

        switch($method){
        default:
            $value = $_POST;
        break;
        case "cookie":
            $value = $_COOKIE;
        break;
        case "get":
            $value = $_GET;
        break;
        }
        
        // finally we get the index value from the specified array
        foreach($array as $index){
            $value = $value[$index];
        }
        
        switch($method){
        default:
            $_POST[$str]   = $value;
        break;
        case "cookie":
            $_COOKIE[$str] = $value;
        break;
        case "get":
            $_GET[$str]    = value;
        break;
        }
                
        return $value;

    }
    
}

?>