<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Ads extends Controller {
	function Ads() {
		parent::Controller();
		$this->load->model('Ads_model', 'model');
		$this->model->get_adsconfig();
	}
	
	function index(){
		$r['rows'] = $this->model->get_for_list('/ads/index/');
		$r['page_title'] = $this->menu->get_page_title();
		$this->head->append_title($r['page_title']);
		$data['html'] = $this->load->cview('dsp-ads-list', $r);
		$this->load->view($this->template->get('dir').'template', $data);
	}
	
	function read($slug){
		$r['row'] = $this->model->get_ads_by_slug($slug);
		if( !$r['row'] )
			show_404();
		
		$this->load->helper('text');
		
		$this->head->assign_title(ucwords(htmlentities2(utf8_strip_non_ascii_ctrl($r['row']->title))));
		$this->head->assign_meta_tag('keywords', $this->model->convert_tag_to_keyword($r['row']->tags));
		$this->head->assign_meta_tag('description', htmlentities2(utf8_strip_non_ascii_ctrl(character_limiter($r['row']->content, 255, ''))));
		$data['html'] = $this->load->cview('dsp-ads-read', $r);
		//$this->output->cache(90);
		$this->load->view($this->template->get('dir').'template', $data);
	}
	
	function tag($tag){
		
		$r['rows'] = $this->model->get_ads_by_tag($tag);
		$r['tag'] = $this->model->get_tag($tag);
		$r['premium'] = $this->model->get_premium_ads_by_tag($tag);
		$this->head->append_title(ucwords($r['tag']));
		$r['page_title'] = 'Tag: '.ucwords($r['tag']);
		$data['html'] = $this->load->cview('dsp-ads-list', $r);
		$this->load->view($this->template->get('dir').'template', $data);
	}
	
	function tags(){
		$r['row'] = $this->model->get_tags();
		$r['page_title'] = $this->menu->get_page_title();
		$this->head->append_title($r['page_title']);
		$data['html'] = $this->load->cview('dsp-tags-list', $r);
		$this->load->view($this->template->get('dir').'template', $data);
	}
	
	function popular(){
		$r['rows'] = $this->model->get_popular_ads('free');
		$r['page_title'] = $this->menu->get_page_title();
		$this->head->append_title($r['page_title']);
		$data['html'] = $this->load->cview('dsp-ads-list', $r);
		$this->load->view($this->template->get('dir').'template', $data);
	}
	
	function today(){
		$r['rows'] = $this->model->get_ads_today('free');
		$data['page_title'] = $r['page_title'] = 'Iklan Hari Ini';
		$this->head->append_title($r['page_title']);
		$data['html'] = $this->load->cview('dsp-ads-list', $r);
		$this->load->view($this->template->get('dir').'template', $data);
	}
	
	function yesterday(){
		$r['rows'] = $this->model->get_ads_yesterday('free');
		$data['page_title'] = $r['page_title'] = 'Iklan Kemarin';
		$this->head->append_title($r['page_title']);
		$data['html'] = $this->load->cview('dsp-ads-list', $r);
		$this->load->view($this->template->get('dir').'template', $data);
	}

	function category($cat, $parentslug=''){
		$r['rows'] = $this->model->get_ads_by_category($cat, $parentslug, 'free');
		$r['cat'] = $this->model->get_catname($cat, $parentslug);
		$this->head->append_title(ucwords($r['cat']));
		$data['page_title'] = $r['page_title'] = 'Kategori: '.ucwords($r['cat']);
		$data['html'] = $this->load->cview('dsp-ads-list', $r);
		$this->load->view($this->template->get('dir').'template', $data);
	}
	
	function submit(){
		$r['row'] = $this->input->post_object();
		
		if( $this->input->post('task') == 'Pasang' ){
			if( $this->model->store() === false ){
				$r['error_msg'] = $this->model->_get_message();
			} else {
				$r['success_msg'] = $this->model->_get_message();
				$r['row'] = new stdClass();
			}
		}
		
		$r['cats'] = $this->model->get_category_for_list();
		$data['page_title'] = $r['page_title'] = $this->menu->get_page_title();
		
		$this->head->append_title($data['page_title']);
		$data['html'] = $this->load->cview('dsp-ads-form', $r);
		$this->block->set_hide('formpasangiklan');
		$this->load->view($this->template->get('dir').'template', $data);
	}
	
	//update 12 September 2008,
	//enable submit from block
	function submit2(){
		$r['row'] = $this->input->post_object();
		
		if( $this->input->post('dosubmit') == '1' ){
			if( $this->model->store() === false ){
				$r['error_msg'] = $this->model->_get_message();
			} else {
				$r['success_msg'] = $this->model->_get_message();
				$r['row'] = new stdClass();
			}
		}
		echo '<script type="text/javascript">';
		if(!empty($r['error_msg'])){
			echo 'html="<p>'.preg_replace('/(\r\n|\n|\r)/', '', $r['error_msg']).'</p>";';
			echo 'parent.showAdsMessage(html);';
		}
		else{
			echo 'html="<p>'.preg_replace('/(\r\n|\n|\r)/', '', $r['success_msg']).'</p>";';
			echo 'parent.showAdsMessage(html);';
		}
		echo '</script>';
	}
	
	function step1(){
		$status = FALSE;
		session_start();
		if( $this->input->post('dosubmit') == '1' ){
			$status 	= $this->model->validate2();
			$message	= $this->model->_get_message();
		}
		
		echo '<script type="text/javascript">';
		if ($status){
			$image = $this->model->_upload_image();
			$_SESSION['post'] 			= $_POST;
			$_SESSION['post']['image'] 	= $image;
			$html = '<iframe name="adsAction2" id="adsAction2" height="500" src="'.site_url2('ads/step2').'" width="94%" frameborder="0" style="color:#fff;"></iframe>';
			echo "html='".preg_replace('/(\r\n|\n|\r)/', '', $html)."';";
			echo 'parent.showAdsMessage(html); parent.hide_form();';
		} else {
			echo "html='<p style=\"padding:7px; color: #fff; background: #b50000; margin:10px 0 0 0;\">".preg_replace('/(\r\n|\n|\r)/', '', $message)."</p>';";
			echo 'parent.showAdsMessage(html);';
		}
		echo '</script>';
	}
	
	function step2(){
		session_start();
		//_print_r($_SESSION); die;
		if (!isset($_SESSION['post']))
		{
			$r['success_msg'] = 'Session Anda telah berakhir atau Anda belum mengisi form pasang iklan.<br />Silahkan klik <a href="javascript:parent.show_form();" target="_parent">di sini</a> untuk menampilkan form pasang iklan.';
		} 
		else 
		{
			if ($this->input->post('dosubmit') === '1' AND $_SESSION['token'] === $this->input->post('token'))
			{
				if ($this->model->store2())
				{
					$r['success_msg'] = $this->model->_get_message();
					//$row = $this->model->get_ads_by_id($this->model->iklanid);
					//$r['success_msg'] .= '<script type="text/javascript">parent.location.href="'.site_url('/iklan/'.$row->slug).'";</script>';
					unset($_SESSION['post']);
					/*
					echo '<script type="text/javascript">';
					echo "html='".preg_replace('/(\r\n|\n|\r)/', '', $success_msg)."';";
					echo 'parent.showAdsMessage(html);';
					echo '</script>';
					
					return;
					*/
				}
				else
				{
					$r['err_msg'] = $this->model->_get_message();
				}
			}
		}
		
		$_SESSION['token'] = $r['token'] = random_string('unique', 20);
		
		$this->load->cview('dsp-form-captcha', $r, FALSE);
	}
	
	function search(){
		$this->load->helper('inflector');
		$this->load->helper('text');
		
		$r['rows'] = $this->model->search();
		$this->head->append_title('Hasil Pencarian');
		
		$data['page_title'] = 'Hasil Pencarian: '.$r['rows']['keyword'];
		
		$data['html'] = $this->load->cview('dsp-search-result', $r, true);
		$this->load->view($this->template->get('dir').'/template', $data);
	}
}
?>