<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Ads_model extends Model {
	function Ads_model(){
		parent::Model();
	}
		
	function get_for_list($baseurl=''){
		$this->load->library('pagination');
	
		$this->db->select('COUNT(id)');
		$r = $this->db->getwhere('iklan_baris', "typeiklan='free'", 1);
		
		$config['base_url'] = $baseurl ? $baseurl:$this->uri->slash_segment(1, 'leading').$this->uri->slash_segment(2, 'both');
		
		$config['base_url'] = trim($config['base_url'], '/') != '' ? $config['base_url']:'/home/index/';
		$config['total_rows'] 	= $r->get_one();
		$config['per_page'] 	= $this->config->item('ads_maxlistfree');
		$config['uri_segment'] 	= 3;	
		$config['first_link']	= '&laquo;&laquo;';
		$config['prev_link']	= '&laquo;';
		$config['next_link']	= '&raquo;';
		$config['last_link']	= '&raquo;&raquo;';
		$this->pagination->initialize($config);
		
		$limit = $this->pagination->get_limit();
		$offset = $this->pagination->get_offset();
		
		$this->db->select();
		$this->db->orderby('created_date', 'DESC');
		$r = $this->db->getwhere('iklan_baris', "typeiklan='free'", $limit, $offset );
		$rows = array();
		foreach( $r->result() as $row ){
			$this->db->select('t.tag, t.slug');
			$this->db->from(array('tags as t', 'iklan2tag as it'));
			$r2 = $this->db->getwhere('', "t.tagid=it.tagid AND it.iklanid=$row->id");
			$row->tags = $r2->result();

			$this->db->select('slug, catname as name, parentid');
			$r3 = $this->db->getwhere('kategori_iklan', "catid=".$this->db->escape($row->catid));
			$row->cat = $r3->row();
			if( is_object($row->cat) )
				$row->cat->parentslug = $this->get_parent_slug($row->cat->parentid);
			
			$rows[] = $row;
		}
		
		return $rows;
	}

	function get_premium_ads($orderby='startdate', $ordertype='ASC'){
		$this->db->select();
		$this->db->orderby($orderby, $ordertype);
		$now = now();
		$r = $this->db->getwhere('iklan_baris', "typeiklan='premium' AND (startdate<=$now AND enddate>=$now)");
		$rows = array();
		foreach( $r->result() as $row ){
			$this->db->select('t.tag, t.slug');
			$this->db->from(array('tags as t', 'iklan2tag as it'));
			$r2 = $this->db->getwhere('', "t.tagid=it.tagid AND it.iklanid=$row->id");
			$row->tags = $r2->result();

			$this->db->select('slug, catname as name, parentid');
			$r3 = $this->db->getwhere('kategori_iklan', "catid=".$this->db->escape($row->catid));
			$row->cat = $r3->row();
			if( is_object($row->cat) )
				$row->cat->parentslug = $this->get_parent_slug($row->cat->parentid);
			
			$rows[] = $row;
		}

		return $rows;
	}
	
	function get_popular_ads($type='free'){
		$this->load->library('pagination');
	
		$this->db->select('COUNT(id)');
		$r = $this->db->getwhere('iklan_baris', "typeiklan=".$this->db->escape($type), 1);
		
		$config['base_url'] = $this->uri->slash_segment(1, 'leading').$this->uri->slash_segment(2, 'both');
		
		$config['total_rows'] 	= $r->get_one();
		$config['per_page'] 	=  $this->config->item('ads_maxlistfree');
		$config['uri_segment'] 	= 3;	
		$config['first_link']	= '&laquo;&laquo;';
		$config['prev_link']	= '&laquo;';
		$config['next_link']	= '&raquo;';
		$config['last_link']	= '&raquo;&raquo;';
		$this->pagination->initialize($config);
		
		$limit = $this->pagination->get_limit();
		$offset = $this->pagination->get_offset();
		
		$this->db->select();
		$this->db->orderby('hits', 'DESC');
		if( $type == 'premium' ){
			$now = now();
			$r = $this->db->getwhere('iklan_baris', "typeiklan=".$this->db->escape($type)." AND (startdate<=$now AND enddate>=$now)" );
		} else {
			$r = $this->db->getwhere('iklan_baris', "typeiklan=".$this->db->escape($type), $limit, $offset );
		}
		$rows = array();
		foreach( $r->result() as $row ){
			$this->db->select('t.tag, t.slug');
			$this->db->from(array('tags as t', 'iklan2tag as it'));
			$r2 = $this->db->getwhere('', "t.tagid=it.tagid AND it.iklanid=$row->id");
			$row->tags = $r2->result();

			$this->db->select('slug, catname as name, parentid');
			$r3 = $this->db->getwhere('kategori_iklan', "catid=".$this->db->escape($row->catid));
			$row->cat = $r3->row();
			if( is_object($row->cat) )
				$row->cat->parentslug = $this->get_parent_slug($row->cat->parentid);
			
			$rows[] = $row;
		}
		
		return $rows;
	}
	
	function get_ads_by_tag($tag, $offset=10){
		$this->load->library('pagination');
	
		$adsid = $this->get_adsid_by_tag($tag);
		$rows = array();
		if( count($adsid) > 0 ){
			$where = "id IN (".implode(', ', $adsid).")";
			$this->db->select('COUNT(id)');
			$r = $this->db->getwhere('iklan_baris', "typeiklan='free' AND ".$where, 1);
			
			$config['base_url'] = $this->uri->slash_segment(1, 'leading').$this->uri->slash_segment(2, 'both');
			$config['total_rows'] = $r->get_one();
			$config['per_page'] = $this->config->item('ads_maxlistfree');
			$config['uri_segment'] = 3;
			$config['first_link']	= '&laquo;&laquo;';
			$config['prev_link']	= '&laquo;';
			$config['next_link']	= '&raquo;';
			$config['last_link']	= '&raquo;&raquo;';
		
			$this->pagination->initialize($config);
			
			$limit = $this->pagination->get_limit();
			$offset = $this->pagination->get_offset();
			
			$this->db->select();
			$this->db->orderby('created_date', 'DESC');
			$r = $this->db->getwhere('iklan_baris', "typeiklan='free' AND ".$where, $limit, $offset );
			
			foreach( $r->result() as $row ){
				$this->db->select('t.tag, t.slug');
				$this->db->from(array('tags as t', 'iklan2tag as it'));
				$r2 = $this->db->getwhere('', "t.tagid=it.tagid AND it.iklanid=$row->id");
				$row->tags = $r2->result();

				$this->db->select('slug, catname as name, parentid');
				$r3 = $this->db->getwhere('kategori_iklan', "catid=".$this->db->escape($row->catid));
				$row->cat = $r3->row();
				if( is_object($row->cat) )
					$row->cat->parentslug = $this->get_parent_slug($row->cat->parentid);
				
				$rows[] = $row;
			}
		}
		
		return $rows;
	}

	function get_premium_ads_by_tag($tag){
		$adsid = $this->get_adsid_by_tag($tag);
		$rows = array();
		if( count($adsid) > 0 ){
			$where = "id IN (".implode(', ', $adsid).")";
			$now = now();
			$this->db->select();
			$this->db->orderby('startdate', 'ASC');
			$r = $this->db->getwhere('iklan_baris', "typeiklan='premium' AND (startdate<=$now AND enddate>=$now) AND ".$where );
			
			foreach( $r->result() as $row ){
				$this->db->select('t.tag, t.slug');
				$this->db->from(array('tags as t', 'iklan2tag as it'));
				$r2 = $this->db->getwhere('', "t.tagid=it.tagid AND it.iklanid=$row->id");
				$row->tags = $r2->result();

				$this->db->select('slug, catname as name, parentid');
				$r3 = $this->db->getwhere('kategori_iklan', "catid=".$this->db->escape($row->catid));
				$row->cat = $r3->row();
				if( is_object($row->cat) )
					$row->cat->parentslug = $this->get_parent_slug($row->cat->parentid);
				
				$rows[] = $row;
			}
		}
		
		return $rows;
	}
	
	function get_adsid_by_tag($tag){
		$this->db->select('it.iklanid');
		$this->db->from(array('tags as t', 'iklan2tag as it'));
		$r = $this->db->getwhere('', "it.tagid=t.tagid AND t.slug=".$this->db->escape($tag));
		$rows = array();
		foreach ($r->result() as $row){
			$rows[] = $row->iklanid;
		}
		
		return $rows;
	}

	function get_ads_by_category($cat, $parent, $type){
		$this->load->library('pagination');
		
		$rows = array();
		$catid = $this->get_catid($cat, $parent);
			
		$this->db->select('COUNT(id)');
		$r = $this->db->getwhere('iklan_baris', "catid=$catid AND typeiklan='$type'", 1);
		
		$config['base_url'] = $this->uri->slash_segment(1, 'leading').$this->uri->slash_segment(2, 'both');
		if( !empty($parent) )
			$config['base_url'] = $this->uri->slash_segment(1, 'leading').$this->uri->slash_segment(2, 'leading').$this->uri->slash_segment(3, 'both');
			
		$config['total_rows'] = $r->get_one();
		$config['per_page'] = $this->config->item('ads_maxlistfree');
		$config['uri_segment'] = !empty($parent) ? 4:3;
		$config['first_link']	= '&laquo;&laquo;';
		$config['prev_link']	= '&laquo;';
		$config['next_link']	= '&raquo;';
		$config['last_link']	= '&raquo;&raquo;';
	
		$this->pagination->initialize($config);
		
		$limit = $this->pagination->get_limit();
		$offset = $this->pagination->get_offset();
		
		$this->db->select();
		
		if( $type=='premium' ){
			$now = now();
			$this->db->orderby('startdate', 'ASC');
			$r = $this->db->getwhere('iklan_baris', "catid=$catid AND typeiklan='$type'"." AND (startdate<=$now AND enddate>=$now)" );
		} else {
			$this->db->orderby('created_date', 'DESC');
			$r = $this->db->getwhere('iklan_baris', "catid=$catid AND typeiklan='$type'", $limit, $offset );
		}
		
		foreach( $r->result() as $row ){
			$this->db->select('t.tag, t.slug');
			$this->db->from(array('tags as t', 'iklan2tag as it'));
			$r2 = $this->db->getwhere('', "t.tagid=it.tagid AND it.iklanid=$row->id");
			$row->tags = $r2->result();

			$this->db->select('slug, catname as name, parentid');
			$r3 = $this->db->getwhere('kategori_iklan', "catid=".$this->db->escape($row->catid));
			$row->cat = $r3->row();
			if( is_object($row->cat) )
				$row->cat->parentslug = $this->get_parent_slug($row->cat->parentid);
			
			$rows[] = $row;
		}

		return $rows;
	}
	
	function get_tag($slug){
		$this->db->select('tag');
		$r = $this->db->getwhere("tags", "slug=".$this->db->escape($slug));
		
		return $r->get_one();
	}

	function get_catname($slug, $parentslug=''){
		$catname = '';
		if( !empty($parentslug) ){
			$this->db->select('catname');
			$r = $this->db->getwhere("kategori_iklan", "slug=".$this->db->escape($parentslug));
			$catname .= $r->get_one().' - ';
		}
		
		$this->db->select('catname');
		$r = $this->db->getwhere("kategori_iklan", "slug=".$this->db->escape($slug));
		
		$catname .= $r->get_one();
		
		return $catname;
	}
	
	function get_catid($slug, $parentslug=''){
		$this->db->select('catid');
		$r = $this->db->getwhere("kategori_iklan", "slug=".$this->db->escape($parentslug));
		$parentid = intval($r->get_one());
		
		$this->db->select('catid');
		$r = $this->db->getwhere("kategori_iklan", "parentid=".$this->db->escape($parentid)." AND slug=".$this->db->escape($slug));
		
		return $r->get_one();
	}
	
	function get_parent_slug($catid){
		if( empty($catid) )
			return '';
		
		$this->db->select('slug');
		$r = $this->db->getwhere('kategori_iklan', "catid=".$this->db->escape($catid));
		
		return $r->get_one();
	}
	
	function get_ads_by_slug($slug){
		$this->db->select();
		$r = $this->db->getwhere('iklan_baris', "slug=".$this->db->escape($slug));
		
		if( $r->num_rows == 0 )
			return false;
		
		$row = $r->row();
		
		$this->db->select('t.tag, t.slug, t.tagid');
		$this->db->from(array('tags as t', 'iklan2tag as it'));
		$r2 = $this->db->getwhere('', "t.tagid=it.tagid AND it.iklanid=$row->id");
		$row->tags = $r2->result();
		$row->related = $this->get_related_ads($row->id, $row->tags);
		
		$this->db->select('slug, catname as name, parentid');
		$r3 = $this->db->getwhere('kategori_iklan', "catid=".$this->db->escape($row->catid));
		$row->cat = $r3->row();
		if( is_object($row->cat) )
			$row->cat->parentslug = $this->get_parent_slug($row->cat->parentid);
		
		$this->_update_ads_hits($row->id);
		
		return $row;
	}
	
	function get_ads_by_id($id)
	{
		$this->db->select();
		$r = $this->db->getwhere('iklan_baris', "id=".$this->db->escape($id));
		
		if( $r->num_rows == 0 )
			return false;
		
		return $r->row();
	}
	
	function get_related_ads($iklanid, $tags){
		$tagid = array();
		foreach( $tags as $row ){
			$tagid[] = $row->tagid;
		}
		$related = array();
		if( count($tagid) > 0 ){
			$this->db->select('iklanid');
			$r = $this->db->getwhere('iklan2tag', "tagid IN (".implode(',', $tagid).")");
			$adsid = array();
			foreach( $r->result() as $row ){
				$adsid[] = $row->iklanid;
			}
			if( count($adsid) > 0 ){
				$this->db->select();
				$r = $this->db->getwhere('iklan_baris', "id IN (".implode(',', $adsid).") AND id!=".$this->db->escape($iklanid), 10);
				foreach( $r->result() as $row ){
					$this->db->select('t.tag, t.slug');
					$this->db->from(array('tags as t', 'iklan2tag as it'));
					$r2 = $this->db->getwhere('', "t.tagid=it.tagid AND it.iklanid=$row->id");
					$row->tags = $r2->result();
					
					$related[] = $row;
				}
			}
		}
		
		return $related;
	}
	
	function _update_ads_hits($id){
		$sql = "UPDATE ".$this->db->dbprefix."iklan_baris SET hits=(hits + 1) WHERE id=".$this->db->escape($id);
		$this->db->simple_query($sql);
	}
	
	function validate(){
		$is_e = false;
		$title = $this->input->post('title', true);
		$content = strip_tags($this->input->post('content', true));
		$tags = $this->input->post('tags', true);
		$this->_parse_tags($tags, $title);
		$scode = $this->input->post('scode', true);
		$name = $this->input->post('name', true);
		$email = $this->input->post('email', true);
		$type = $this->input->post('type', true);
		$catid = $this->input->post('catid', true);
		
		$msg = '';
		
		if( trim(strip_tags($name)) == '' ){
			$msg .= 'Nama tidak boleh kosong.<br />';
			$is_e = true;
		}
		if( !preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $email) ){
			$msg .= 'Email yang Anda masukkan tidak valid.<br />';
			$is_e = true;
		}
		if( trim(strip_tags($catid)) == '' ){
			$msg .= 'Kategori Iklan tidak boleh kosong.<br />';
			$is_e = true;
		}
		if( trim(strip_tags($title)) == '' ){
			$msg .= 'Judul Iklan tidak boleh kosong.<br />';
			$is_e = true;
		}
		if( trim($content) == '' ){
			$msg .= 'Isi Iklan tidak boleh kosong.<br />';
			$is_e = true;
		}
		if( trim($content) != '' && strlen($content) < $this->config->item('ads_mincontent') ){
			$msg .= 'Isi Iklan tidak boleh kurang dari '.$this->config->item('ads_mincontent').'.<br />';
			$is_e = true;
		}
		/*
		if( count($this->tags) < 1 ){
			$msg .= 'Tags tidak boleh kosong.<br />';
			$is_e = true;
		}
		*/
		if( trim(strip_tags($scode)) == '' ){
			$msg .= 'Kode captcha tidak boleh kosong.<br />';
			$is_e = true;
		}
		
		$this->load->library('iwmcaptcha', array('sessvar'=>md5('submitads')));
		if( trim(strip_tags($scode)) != '' && $this->iwmcaptcha->Validate($scode) !== true ){
			$msg .= 'Kode captcha tidak valid.<br />';
			$is_e = true;
		}
		
		if( $is_e ){
			$this->message = $msg;
			return false;
		}
		
		return true;
	}
	
	
	function validate2(){
		$is_e = false;
		$title = $this->input->post('title', true);
		$content = strip_tags($this->input->post('content', true));
		$tags = $this->input->post('tags', true);
		$this->_parse_tags($tags, $title);
		$scode = $this->input->post('scode', true);
		$name = $this->input->post('name', true);
		$email = $this->input->post('email', true);
		$type = $this->input->post('type', true);
		$catid = $this->input->post('catid', true);
		
		$msg = '';
		
		if( trim(strip_tags($name)) == '' ){
			$msg .= 'Nama tidak boleh kosong.<br />';
			$is_e = true;
		}
		if( !preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $email) ){
			$msg .= 'Email yang Anda masukkan tidak valid.<br />';
			$is_e = true;
		}
		if( trim(strip_tags($catid)) == '' ){
			$msg .= 'Kategori Iklan tidak boleh kosong.<br />';
			$is_e = true;
		}
		if( trim(strip_tags($title)) == '' ){
			$msg .= 'Judul Iklan tidak boleh kosong.<br />';
			$is_e = true;
		}
		if( trim($content) == '' ){
			$msg .= 'Isi Iklan tidak boleh kosong.<br />';
			$is_e = true;
		}
		if( trim($content) != '' && strlen($content) < $this->config->item('ads_mincontent') ){
			$msg .= 'Isi Iklan tidak boleh kurang dari '.$this->config->item('ads_mincontent').'.<br />';
			$is_e = true;
		}
		/*
		if( count($this->tags) < 1 ){
			$msg .= 'Tags tidak boleh kosong.<br />';
			$is_e = true;
		}
		*/
		
		if( $is_e ){
			$this->message = $msg;
			return false;
		}
		
		return true;
	}
	
	function _check_website($website){
		if( '' == trim($website) )
			return '';
		
		if( substr($website, 0, 7) != 'http://' && substr($website, 0, 8) != 'https://' ){
			$website = 'http://'.$website;
		}
		
		return (!preg_match("/^(http|https):\/\/((([a-z0-9_\-]+\.)([a-z0-9_\-]+\.))|([a-z0-9_\-]+\.))+[a-z]{2,6}/ix", $website)) ? '':$website;
	}
	
	function store(){
		if( $this->validate() === false ){
			return false;
		}
		
		$this->from_sidebar = FALSE;
		
		$post['website'] 	= $this->_check_website($this->input->post('website', true));
		$post['title'] 		= strip_tags($this->input->post('title', true));
		$post['content'] 	= strip_tags($this->input->post('content', true));
		$post['name'] 		= strip_tags($this->input->post('name', true));
		$post['email'] 		= strip_tags($this->input->post('email', true));
		$post['city'] 		= strip_tags($this->input->post('city', true));
		$post['phone'] 		= strip_tags($this->input->post('phone', true));
		$post['typeiklan'] 	= $this->input->post('type', true);
		$post['catid'] 		= $this->input->post('catid', true);
		$post['lama'] 		= $this->input->post('masatayang', true);
		$post['image'] 		= $this->_upload_image();
		
		return $this->_save($post);
	}
	
	function store2()
	{
		$scode = $this->input->post('scode', true);
		if( trim(strip_tags($scode)) == '' ){
			$this->message = 'Kode captcha tidak boleh kosong.';
			return FALSE;
		}
		
		$this->load->library('iwmcaptcha', array('sessvar'=>md5('submitads')));
		if( $this->iwmcaptcha->Validate($scode) !== true ){
			$this->message = 'Kode captcha tidak valid.';
			return FALSE;
		}
		
		$this->load->helper('security');
		
		$this->from_sidebar = TRUE;
			
		$post['website'] 	= $this->_check_website($_SESSION['post']['website']);
		$post['title'] 		= xss_clean(strip_tags($_SESSION['post']['title']), true);
		$post['content'] 	= xss_clean(strip_tags($_SESSION['post']['content']), true);
		$post['name'] 		= xss_clean(strip_tags($_SESSION['post']['name']), true);
		$post['email'] 		= xss_clean(strip_tags($_SESSION['post']['email']), true);
		$post['city'] 		= xss_clean(strip_tags($_SESSION['post']['city']), true);
		$post['phone'] 		= strip_tags($_SESSION['post']['phone'], true);
		$post['typeiklan'] 	= xss_clean($_SESSION['post']['type'], true);
		$post['catid'] 		= xss_clean($_SESSION['post']['catid'], true);
		$post['lama'] 		= xss_clean($_SESSION['post']['masatayang'], true);
		$post['image'] 		= xss_clean($_SESSION['post']['image'], true);
		
		$tags = xss_clean($_SESSION['post']['tags'], true);
		$this->_parse_tags($tags, $post['title']);
		
		return $this->_save($post);
	}
	
	function _save($post)
	{
		if( $post['typeiklan'] == 'premium' ){
			$post['tagtmp'] = serialize($this->tags);
		}
		
		$post['ip_address'] = $this->input->ip_address();
		
		$id = $this->_check_iklan($post);
		if( !$id ){
			$post['created_date'] = now();
			$post['slug'] = $this->_create_slug($post['title']);
			
			$r = $this->db->insert('iklan_baris', $post);
			if( !$r ){
				$this->message = 'Iklan Anda gagal disimpan.<br />Silahkan hubungi administrator untuk melaporkan hal ini.';
				return false;
			}
			
			$id = $this->db->insert_id();
		} else {
			$update['created_date'] = now();
			if ($post['image']){
				$update['image'] = $post['image'];
			}
			
			$r = $this->db->update('iklan_baris', $update, "id=$id");
			if( !$r ){
				$this->message = 'Iklan Anda gagal disimpan.<br />Silahkan hubungi administrator untuk melaporkan hal ini.';
				return false;
			}
		}
		
		$this->iklanid = $id;
		if( $post['typeiklan'] == 'free' ){
			$this->_store_tags();
			$this->_assign_tags_to_ads();
		}
		
		$row = $this->get_ads_by_id($this->iklanid);
		
		$msg = ' Silahkan klik <a href="'.site_url('/iklan/'.$row->slug).'" target="_parent">di sini</a> untuk melihat iklan Anda.';
		if( $post['typeiklan'] == 'premium' ){
			$this->load->helper('email');
			$email['name'] 			= $post['name'];
			$email['adstitle'] 		= $post['title'];
			$email['adscontent'] 	= $post['content'];
			$email['masatayang'] 	= $post['lama'];
			$email['totalpayment'] 	= 'Rp '.format_uang($post['lama'] * $this->config->item('ads_premiumprice'));
			$email['bankdetail'] 	= nl2br($this->config->item('ads_paymentbank'));
			
			@send_mail($post['email'], $email, 'orderiklanpremium');
			$msg = '<br />Untuk mengaktifkan iklan premium Anda, silahkan lakukan pembayaran sebesar '.$email['totalpayment'].' ke salah satu rekening berikut.<br /><br />'.$email['bankdetail'];
		}
		
		$this->message = 'Iklan Anda berhasil disimpan.'.$msg;
		return true;
	}
	
	function get_tags($offset=200, $orderby='counter', $ordertype='DESC'){
		$this->db->select('tag, slug, counter');
		$order = '';
		if( $orderby != '' ){
			if( $ordertype == '' )
				$ordertype = 'ASC';
			
			$order .= $orderby.' '.$ordertype.', ';
		}
		
		$order .= 'tag ASC';
		
		$this->db->orderby($order);
		$this->db->groupby('slug');
		$r = $this->db->getwhere('tags', "counter>0", $offset);
		
		$rtn['rows'] = $r->result();
		
		$this->db->select('counter');
		$this->db->orderby('counter', 'DESC');
		$this->db->groupby('slug');
		$r = $this->db->get('tags');
		$rtn['max'] = $r->get_one();
		
		return $rtn;
	}
	
	function get_category_for_list($parentid=0){
		$this->db->select('catid, catname as name');
		$this->db->orderby('catname');
		$r = $this->db->getwhere('kategori_iklan', "parentid=$parentid");

		$rows = array();
		foreach( $r->result() as $row ){
			$row->subcats = $this->get_category_for_list($row->catid);
			$rows[] = $row;
		}
		
		return $rows;
	}

	function get_categories($parentid=0){
		$this->db->select('catid, slug, catname as name');
		$this->db->orderby('catname');
		$r = $this->db->getwhere('kategori_iklan', "parentid=$parentid");

		$rows = array();
		foreach( $r->result() as $row ){
			$row->subcats = $this->get_categories($row->catid);
			$rows[] = $row;
		}
		
		return $rows;
	}
	
	function _upload_image(){
		$config['upload_path'] = ROOTPATH.'images/iklan/'; 
		$config['allowed_types'] = 'gif|jpg|png';
		$config['encrypt_name'] = false;
		
		$this->load->library('upload', $config);
		
		if( !$this->upload->do_upload('image') ){
			return '';
		}
		
		$d = $this->upload->data();
		
		$config2['source_image'] = $config['upload_path'].$d['file_name'];
		$config2['create_thumb'] = FALSE;
		$config2['maintain_ratio'] = TRUE;
		$config2['width'] = 70;
		$config2['height'] = 70;
		$config2['quality'] = '100';
		$this->load->library('image_lib', $config2);
		if( $this->image_lib->resize() === true )
			return $d['file_name'];
		
		@unlink($config['upload_path'].$d['file_name']);
		
		return '';
	}
	
	function _check_iklan($post){
		$check['content'] = $post['content'];
		$check['typeiklan'] = $post['typeiklan'];
		$check['title'] = $post['title'];
		$check['website'] = $post['website'];
		
		$this->db->select('id');
		$r = $this->db->getwhere('iklan_baris', $check, 1);
		$id = $r->get_one();
	
		return $id;
	}
	
	function _store_tags(){
		$this->tags_id = array();
		foreach( $this->tags as $tag ){
			$tagslug = url_title($tag);
			$this->db->select('tagid');
			$r = $this->db->getwhere('tags', "slug=".$this->db->escape($tagslug), 1);
			$id = $r->get_one();
			
			if( !$id ){
				$data['tag'] = $tag;
				$data['counter'] = 1;
				$data['slug'] = $tagslug;
				$r = $this->db->insert('tags', $data);
				$id = $this->db->insert_id();
			} else {
				$this->db->select('1');
				$r = $this->db->getwhere('iklan2tag', "tagid=$id AND iklanid=".$this->iklanid, 1);
				$e = $r->get_one();
				if( !$e ){
					$this->db->select('counter');
					$r = $this->db->getwhere('tags', "tagid=$id", 1);
					$counter = $r->get_one();
					$update['counter'] = $counter + 1;
					$r = $this->db->update('tags', $update, "tagid=$id");
				}
			}
			$this->tags_id[] = $id;
		}
	}
	
	function _assign_tags_to_ads(){
		foreach( $this->tags_id as $tag ){
			$this->db->select('1');
			$r = $this->db->getwhere('iklan2tag', "tagid=$tag AND iklanid=".$this->iklanid, 1);
			$e = $r->get_one();
			if( !$e ){
				$data['tagid'] = $tag;
				$data['iklanid'] = $this->iklanid;
				$this->db->insert('iklan2tag', $data);
			}
		}
	}
	
	function _parse_tags($tags, $title){
		$this->tags = array();
		$tags = strip_tags(strtolower($tags));
		if( trim(strip_tags($tags)) == '' ){
			$title = strip_tags(strtolower($title));
			$tags = preg_replace("#\s+#", ',', $title);
		}
		$tags = preg_replace("#[^A-Za-z0-9,\s]#", '', $tags);
		$tags = explode(',', strtolower($tags));
		
		$this->_parse_banned_word();
		
		$i=1;
		foreach($tags as $tag){
			$tag = trim(strtolower($tag));
			if( $tag != '' && !in_array($tag, $this->tags) && strlen($tag) >= 3 && !in_array($tag, $this->bannedwords) ){
				$this->tags[] = $tag;
				$i++;
			}
			
			if( $i > 5 )
				break;
		}
		
		array_unique($this->tags);
	}
	
	function _parse_banned_word(){
		$banned = $this->config->item('ads_bannedword');
		
		$this->bannedwords = explode("\n", str_replace("\r\n", "\n", $banned));
		array_unique($this->bannedwords);
	}
	
	function _create_slug($str, $num=1, $ori=''){
		$slug = url_title($str);
		
		if( $ori == '' ){
			$ori = $str;
		}
		
		$this->db->select('id');
		$r = $this->db->getwhere('iklan_baris', "slug=".$this->db->escape($slug));
		$id = $r->get_one();
		if( !$id ){
			return $slug;
		}
		
		$slug = $ori.'-'.$num;
		$num++;
		
		return $this->_create_slug($slug, $num, $ori);
	}
	
	function search(){
		$keyword = $this->input->post('q', true);
		$search = $this->input->post('search');
		
		if( $keyword || $search){
			$this->session->set_userdata(array('q' => $keyword));
		} else {
			$keyword = $this->session->userdata('q');
		}
		
		preg_match_all('/".*?("|$)|((?<=[\\s",+])|^)[^\\s",+]+/', stripslashes($keyword), $matches);
		$s = array_map(create_function('$a', 'return trim($a, "\\"\'\\n\\r ");'), $matches[0]);
		
		$where = '1=1';
		if( $keyword != '' ){
			$terms = $s;
			if( is_string($terms) )
				$terms = array($terms);
			$search = '';
			$searchcond = '';
			foreach( (array) $terms as $term ){
				$search .= "{$searchcond}(title LIKE ".$this->db->escape("%".$term."%")." OR content LIKE ".$this->db->escape("%".$term."%").")";
				$searchcond = ' AND ';
			}
			if( count($terms) > 1 && $terms[0] != $args['q'] ){
				$search .= " OR (title LIKE ".$this->db->escape("%".$args['q']."%")." OR content LIKE ".$this->db->escape("%".$args['q']."%").")";
			}
			
			$where .= " AND ($search)";
		}
		
		$rows = array();
		
		$this->load->library('pagination');
		
		$this->db->select('COUNT(id)');
		$r = $this->db->getwhere('iklan_baris', $where, 1);
	
		$config['base_url'] = $this->uri->slash_segment(1, 'leading').$this->uri->slash_segment(2, 'both');
		$config['total_rows'] = $r->get_one();
		$config['per_page'] = 10;
		$config['uri_segment'] = 3;	
		$this->pagination->initialize($config);
		
		$limit = $this->pagination->get_limit();
		$offset = $this->pagination->get_offset();
		
		$this->db->select();
		$r = $this->db->getwhere('iklan_baris', $where, $limit, $offset);
		
		$rows['items'] = array();
		foreach( $r->result() as $row ){
			$this->db->select('t.tag, t.slug');
			$this->db->from(array('tags as t', 'iklan2tag as it'));
			$r2 = $this->db->getwhere('', "t.tagid=it.tagid AND it.iklanid=$row->id");
			$row->tags = $r2->result();
			
			$this->db->select('slug, catname as name, parentid');
			$r3 = $this->db->getwhere('kategori_iklan', "catid=".$this->db->escape($row->catid));
			$row->cat = $r3->row();
			if( is_object($row->cat) )
			$row->cat->parentslug = $this->get_parent_slug($row->cat->parentid);
			
			$rows['items'][] = $row;
		}
		
		$rows['keyword'] = $keyword;
		
		return $rows;
	}
	
	function convert_tag_to_keyword($tags){
		if( !is_array($tags) ){
			$tags = array();
		}
		$keywords = array();
		if( count($tags) > 0 ){
			foreach( $tags as $tag ){
				$keywords[] = $tag->tag;
			}
		}
		
		return implode(', ', $keywords);
	}

	function get_adsconfig($return=false){
		$this->db->select('name, value');
		$r = $this->db->get('iklan_config');
		if( $return )
			return $r->result();

		foreach( $r->result() as $row ){
			$key = 'ads_'.$row->name;
			$this->config->set_item($key, $row->value);
		}
	}
	
	function get_ads_today(){
		$this->load->library('pagination');
		
		$today = mdate('%Y-%m-%d', gmt_to_local(now(), config_item('time_zone')));
		$timezone = timezones(config_item('time_zone')) * 3600;
	
		$this->db->select('COUNT(id)');
		$r = $this->db->getwhere('iklan_baris', "typeiklan='free' AND FROM_UNIXTIME((created_date + $timezone), '%Y-%m-%d')='$today'", 1);
		
		$config['base_url'] = $baseurl ? $baseurl:$this->uri->slash_segment(1, 'leading').$this->uri->slash_segment(2, 'both');
		
		$config['base_url'] = trim($config['base_url'], '/') != '' ? $config['base_url']:'/home/index/';
		$config['total_rows'] 	= $r->get_one();
		$config['per_page'] 	= $this->config->item('ads_maxlistfree');
		$config['uri_segment'] 	= 2;	
		$config['first_link']	= '&laquo;&laquo;';
		$config['prev_link']	= '&laquo;';
		$config['next_link']	= '&raquo;';
		$config['last_link']	= '&raquo;&raquo;';
		$this->pagination->initialize($config);
		
		$limit = $this->pagination->get_limit();
		$offset = $this->pagination->get_offset();
		
		$this->db->select();
		$this->db->orderby('created_date', 'DESC');
		$r = $this->db->getwhere('iklan_baris', "typeiklan='free'  AND FROM_UNIXTIME((created_date + $timezone), '%Y-%m-%d')='$today'", $limit, $offset );
		$rows = array();
		foreach( $r->result() as $row ){
			$this->db->select('t.tag, t.slug');
			$this->db->from(array('tags as t', 'iklan2tag as it'));
			$r2 = $this->db->getwhere('', "t.tagid=it.tagid AND it.iklanid=$row->id");
			$row->tags = $r2->result();

			$this->db->select('slug, catname as name, parentid');
			$r3 = $this->db->getwhere('kategori_iklan', "catid=".$this->db->escape($row->catid));
			$row->cat = $r3->row();
			if( is_object($row->cat) )
				$row->cat->parentslug = $this->get_parent_slug($row->cat->parentid);
			
			$rows[] = $row;
		}
		
		return $rows;
	}
	
	function get_ads_yesterday(){
		$this->load->library('pagination');
		
		$today = mdate('%Y-%m-%d', gmt_to_local(now(), config_item('time_zone')));
		$timezone = timezones(config_item('time_zone')) * 3600;
	
		$this->db->select('COUNT(id)');
		$r = $this->db->getwhere('iklan_baris', "typeiklan='free' AND FROM_UNIXTIME((created_date + $timezone), '%Y-%m-%d')=DATE_SUB('$today', INTERVAL 1 DAY)", 1);
		
		$config['base_url'] = $baseurl ? $baseurl:$this->uri->slash_segment(1, 'leading').$this->uri->slash_segment(2, 'both');
		
		$config['base_url'] = trim($config['base_url'], '/') != '' ? $config['base_url']:'/home/index/';
		$config['total_rows'] 	= $r->get_one();
		$config['per_page'] 	= $this->config->item('ads_maxlistfree');
		$config['uri_segment'] 	= 2;	
		$config['first_link']	= '&laquo;&laquo;';
		$config['prev_link']	= '&laquo;';
		$config['next_link']	= '&raquo;';
		$config['last_link']	= '&raquo;&raquo;';
		$this->pagination->initialize($config);
		
		$limit = $this->pagination->get_limit();
		$offset = $this->pagination->get_offset();
		
		$this->db->select();
		$this->db->orderby('created_date', 'DESC');
		$r = $this->db->getwhere('iklan_baris', "typeiklan='free'  AND FROM_UNIXTIME((created_date + $timezone), '%Y-%m-%d')=DATE_SUB('$today', INTERVAL 1 DAY)", $limit, $offset );
		$rows = array();
		foreach( $r->result() as $row ){
			$this->db->select('t.tag, t.slug');
			$this->db->from(array('tags as t', 'iklan2tag as it'));
			$r2 = $this->db->getwhere('', "t.tagid=it.tagid AND it.iklanid=$row->id");
			$row->tags = $r2->result();

			$this->db->select('slug, catname as name, parentid');
			$r3 = $this->db->getwhere('kategori_iklan', "catid=".$this->db->escape($row->catid));
			$row->cat = $r3->row();
			if( is_object($row->cat) )
				$row->cat->parentslug = $this->get_parent_slug($row->cat->parentid);
			
			$rows[] = $row;
		}
		
		return $rows;
	}
}
?>
