<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Ads extends Controller {
	function Ads() {
		parent::Controller();
		$this->_check_session('backend');
		$this->load->model('Ads_model', 'model');
		$this->load->model('Kategori_model', 'catmodel');
	}

	function premium(){
		if( $this->input->post('task') == 'published' ){
			$this->model->published();
		}
		if( $this->input->post('task') == 'unpublished' ){
			$this->model->unpublished();
		}
		$this->index('premium');
	}

	function free(){
		$this->index('free');
	}
	
	function index($type='free'){
		if( current_user_permision('read') === false )
			noauth();
		
		$data['message'] = $this->session->userdata('message');
		$this->session->unset_userdata('message');
		
		if( $this->input->post('task') == 'delete' ){
			$this->model->delete();
			$data['message'] = $this->model->_get_message();
		}
		
		if( $this->input->post('task') == 'deleteimage' ){
			$this->model->delete_image();
			$data['message'] = $this->model->_get_message();
		}
		
		$row['rows'] = $this->model->get_for_list($type);
		$data['page_title'] = $this->menu->get_page_title('', 'backend');
		
		$data['html'] = $this->load->cview('dsp-ads-list-'.$type, $row, true);
		$data['button'] = $this->model->buttonlist($type);
		
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function add($type){
		if( current_user_permision('write', '/backend/page/index/') === false )
			noauth();
		
		$this->edit($type);
	}
	
	function edit($type, $id=''){
		if( current_user_permision('modify', '/backend/page/index/') === false && $id )
			noauth();
		
		$this->model->get_adsconfig();
		
		if( $this->input->post('task') == 'save' ){
			if( $this->model->store() === false ){
				$data['message'] = $this->model->_get_message();
			}
			else {
				$msg = $this->model->_get_message();
				$this->session->set_userdata(array('message'=>$msg));
				redirect('/backend/ads/'.$type.'/');
			}
		}
		
		$r['row'] = $this->model->get_by_id($id);
		$r['cats'] = $this->model->get_category_for_list();
		$r['type'] = $type;
		$data['page_title'] = $this->menu->get_page_title('/backend/ads/'.$type.'/', 'backend').(@$id ? ' :: Edit':' :: Tambah');
		$data['button'] = $this->model->button_add($type);
		$data['html'] = $this->load->cview('dsp-ads-form', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function kategori($parentid=''){
		if( current_user_permision('read') === false )
			noauth();
		
		if( $this->input->post('task') == 'published' ){
			$this->catmodel->published('Y');
			redirect($this->input->post('backsegment'));
		}
		
		if( $this->input->post('task') == 'unpublished' ){
			$this->catmodel->published('N');
			redirect($this->input->post('backsegment'));
		}
		
		if( $this->input->post('task') == 'delete' ){
			$this->catmodel->delete();
			$this->session->set_userdata(array('message'=>$this->model->_get_message()));
			redirect($this->input->post('backsegment'));
		}
			
		$parentid = $parentid ? $parentid:0;
		$r['rows'] = $this->catmodel->load_list($parentid);
		$r['parentid'] = $parentid;
		$r['parent'] = $this->catmodel->load($parentid);
		$data['page_title'] = $this->menu->get_page_title('', 'backend');
		$data['message'] = $this->session->userdata('message');
		$this->session->unset_userdata('message');
		$data['button'] = $this->catmodel->buttonlist($parentid);
		$data['html'] = $this->load->cview('dsp-kategori-list', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function kategori_add($parentid){
		if( current_user_permision('write', '/backend/iklan/kategori/') === false )
			noauth();
			
		$this->kategori_edit($parentid);
	}
	
	function kategori_edit($parentid, $id=''){
		if( current_user_permision('modify', '/backend/iklan/kategori/') === false && $id )
			noauth();
		
		if( $this->input->post('task') == 'save' ){
			if( $this->catmodel->validation() === false ){
				$data['message'] = $this->catmodel->_get_message();
			}
			elseif( $this->catmodel->store() === false ){
				$data['message'] = $this->catmodel->_get_message();
			}
			else {
				$this->session->set_userdata(array('message' => $this->catmodel->_get_message()));
				$pid = $this->input->post('parentid');
				redirect('/backend/ads/kategori/'.$pid.'/');
			}
		}
		$r['row'] = $this->catmodel->load($id);
		$r['parentid'] = $parentid ? $parentid:0;
		$r['parent'] = $this->catmodel->load_all();
		$data['page_title'] = $this->menu->get_page_title('/backend/ads/kategori/', 'backend').(@$id ? ' :: Edit':' :: Tambah');
		$data['button'] = $this->catmodel->buttonadd($parentid);
		$data['html'] = $this->load->cview('dsp-kategori-add', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}

	function adsconfig(){
		if( current_user_permision('write') === false || current_user_permision('modify') === false  )
			noauth();

		if( $this->input->post('task') == 'save' ){
			$this->model->save_adsconfig();
			$data['message'] = $this->model->_get_message();
		}
		
		$r['rows'] = $this->model->get_config();
		$data['page_title'] = $this->menu->get_page_title('', 'backend');
		$data['button'] = $this->model->button_adsconfig();
		$data['html'] = $this->load->cview('dsp-ads-config', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
}
?>