<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Ads_model extends Model {
	function Ads_model(){
		parent::Model();
	}
		
	function get_for_list($type, $offset=20){
		$this->load->library('pagination');
		
		$keyword = $this->input->post('q');
		$from_session = false;
		if( !$keyword ){
			$keyword = $this->session->userdata($this->uri->segment(4));
			$from_session = true;
		}		
		
		$where = '';
		if( $keyword ){
			$where .= " AND (title LIKE ".$this->db->escape('%'.$keyword.'%')." OR content LIKE ".$this->db->escape('%'.$keyword.'%').")";
			if( $from_session === false )
				$this->session->set_userdata(array('search' => $keyword));
		}
	
		$this->db->select('COUNT(id)');
		$r = $this->db->getwhere('iklan_baris', "typeiklan=".$this->db->escape($type).$where, 1);
		
		$config['base_url'] = $this->uri->slash_segment(1, 'leading').$this->uri->slash_segment(2, 'leading').$this->uri->slash_segment(3, 'both').($keyword ? 'search/':'');
		$config['total_rows'] = $r->get_one();
		$config['per_page'] = $offset;
		$config['uri_segment'] = $keyword ? 5:4;	
		$this->pagination->initialize($config);
		
		$limit = $this->pagination->get_limit();
		$offset = $this->pagination->get_offset();
		
		$this->db->select();
		$this->db->orderby('created_date', 'DESC');
		$r = $this->db->getwhere('iklan_baris', "typeiklan=".$this->db->escape($type).$where, $limit, $offset );
		$rows = array();
		foreach( $r->result() as $row ){
			$this->db->select('t.tag');
			$this->db->from(array('tags as t', 'iklan2tag as it'));
			$r2 = $this->db->getwhere('', "t.tagid=it.tagid AND it.iklanid=$row->id");
			$row->tags = array();
			foreach( $r2->result() as $tag ){
				$row->tags[] = $tag->tag;
			}
			
			$rows[] = $row;
		}
		
		return $rows;
	}
	
	function get_by_id($id){
		if( empty($id) ){
			return $this->input->post_object();
		} else {
			$this->db->select() ;
			$r = $this->db->getwhere('iklan_baris', "id=".$this->db->escape($id));
			$row =  $r->row();
			$tags = @unserialize($row->tagtmp);
			$row->tags = implode(', ', $tags);
			return $row;
		}
	}

	function validation(){
		$is_e = false;
		$title = $this->input->post('title', true);
		$content = strip_tags($this->input->post('content', true));
		$tags = $this->input->post('tags', true);
		$this->_parse_tags($tags, $title);
		$name = $this->input->post('name', true);
		$email = $this->input->post('email', true);
		$type = $this->input->post('type', true);
		$catid = $this->input->post('catid', true);
		
		if( $type == 'premium' && trim(strip_tags($name)) == '' ){
			$this->message['text'] = 'Nama tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		if( $type == 'premium' && !preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $email) ){
			$this->message['text'] = 'Email yang Anda masukkan tidak valid.';
			$this->message['class'] = 'error';
			return false;
		}
		if( trim(strip_tags($catid)) == '' ){
			$this->message['text'] = 'Kategori Iklan tidak boleh kosong.<br />';
			$this->message['class'] = 'error';
			return false;
		}
		if( trim(strip_tags($title)) == '' ){
			$this->message['text'] = 'Judul Iklan tidak boleh kosong.<br />';
			$this->message['class'] = 'error';
			return false;
		}
		if( trim($content) == '' ){
			$this->message['text'] = 'Isi Iklan tidak boleh kosong.<br />';
			$this->message['class'] = 'error';
			return false;
		}
		if( trim($content) != '' && strlen($content) < $this->config->item('ads_mincontent') ){
			$this->message['text'] = 'Isi Iklan tidak boleh kurang dari '.$this->config->item('ads_mincontent').'.<br />';
			$this->message['class'] = 'error';
			return false;
		}

		return true;
	}

	function store(){
		if( $this->validation() === false ){
			return false;
		}
		
		$id = $this->input->post('id');
		$post['website'] = $this->input->post('website', true);
		$post['title'] = $this->input->post('title', true);
		$post['content'] = $this->input->post('content', true);
		$post['name'] = $this->input->post('name', true);
		$post['email'] = $this->input->post('email', true);
		$post['typeiklan'] = $this->input->post('typeiklan', true);
		$post['catid'] = $this->input->post('catid', true);
		$post['lama'] = $this->input->post('lama', true);
		$status = $this->input->post('status', true);
		$oldenddate = $this->input->post('oldenddate', true);
		$oldstartdate = $this->input->post('oldstartdate', true);
		$oldlama = $this->input->post('oldlama', true);
		$oldstatus = $this->input->post('oldstatus', true);
		if( $post['typeiklan'] == 'premium' ){
			$post['tagtmp'] = serialize($this->tags);
		}
		$post['image'] = $this->_upload_image();
		if( $post['image'] == '' ){
			$post['image'] = $this->input->post('imagetmp');
		}
		$sendmail = false;
		if( $id ){
			if( $status == 'active' ){
				if( $oldstatus == 'new' ){
					$post['startdate']  = now();
					$post['enddate'] = $post['startdate'] + ($post['lama'] * 30 * 24 * 60 * 60);
					$sendmail = true;
				}
				
				if( $oldstatus == 'active' ){
					$post['enddate'] = $oldstartdate + ($post['lama'] * 30 * 24 * 60 * 60);
				}
				
				if( $oldstatus == 'expired' ){
					$post['startdate']  = now();
					$post['enddate'] = $post['startdate'] + ($post['lama'] * 30 * 24 * 60 * 60);
					$sendmail = true;
				}
				
				if( $oldstatus == 'inactive' ){
					$post['startdate']  = $oldstartdate;
					$post['enddate'] = $post['startdate'] + ($post['lama'] * 30 * 24 * 60 * 60);
					$sendmail = false;
				}
			}
			
			if( $status == 'inactive' ){
				$post['enddate'] = 0;
			}

			$r = $this->db->update('iklan_baris', $post, "id=".$this->db->escape($id));
			if( !$r ){
				$this->message['text'] = 'Iklan gagal disimpan.';
				$this->message['class'] = 'error';
				return false;
			}
		} else {
			$post['slug'] = $this->_create_slug($this->input->post('title'));
			$post['created_date'] = now();
			if( $status == 'active' ) {
				$post['startdate']  = now();
				$post['enddate'] = $post['startdate'] + ($post['lama'] * 30 * 24 * 60 * 60);
				$sendmail = false;
			}
			$r = $this->db->insert('iklan_baris', $post);
			if( !$r ){
				$this->message['text'] = 'Iklan gagal disimpan.';
				$this->message['class'] = 'error';
				return false;
			}
			$id = $this->db->insert_id();
		}

		$this->iklanid = $id;

		if( ($post['typeiklan'] == 'premium' && $status=='active') || $post['typeiklan'] == 'free' ){
			$this->_store_tags($this->tags);
			$this->_assign_tags_to_ads();
		}
		
		if( $sendmail ){
			$email['name'] = $post['name'];
			$email['adstitle'] = $post['title'];
			$email['adscontent'] = $post['content'];
			$email['expiredate'] = mdate('%d %F %Y', gmt_to_local($post['enddate'], $this->config->item('time_zone')));
			$this->load->helper('email');
			send_mail($post['email'], $email, 'aktivasiiklanpremium');
		}

		$this->message['text'] = 'Iklan berhasil disimpan.';
		$this->message['class'] = 'ok';
		return true;
	}

	function published(){
		$ids = $this->input->post('id');
		$stotal = array();
		$ftotal = array();
		$emails = array();
		$i = 0;
		foreach( $ids as $id ){
			$this->db->select();
			$r = $this->db->getwhere('iklan_baris', "id=$id");
			$row = $r->row();
			$status = $this->get_ad_status($row);
			if( $status == 'new' || $status == 'expired' ){
				$post['startdate'] = now();
				$sendmail = true;
			} else {
				$post['startdate'] = $row->startdate;
				$sendmail = false;
			}
			$post['enddate'] = $post['startdate'] + ($row->lama * 30 * 24 * 60 * 60);
			$r2 = $this->db->update('iklan_baris', $post, "id=".$id);
			
			if( !$r2 ){
				$ftotal[] = $row->title;
			} else {
				$this->iklanid = $id;
				$tags = @unserialize($row->tagtmp) ;
				$this->_store_tags($tags);
				$this->_assign_tags_to_ads();
				if( $sendmail ){
					$emails[$i]['name'] = $row->name;
					$emails[$i]['email'] = $row->email;
					$emails[$i]['adstitle'] = $row->title;
					$emails[$i]['adscontent'] = $row->content;
					$emails[$i]['expiredate'] = mdate('%d %F %Y', gmt_to_local($post['enddate'], $this->config->item('time_zone')));
				}
				
				$i++;
				$stotal[] = $id;
			}
		}
		
		$this->load->helper('email');
		foreach( $emails as $email ){
			$to = $email['email'];
			unset($email['email']);
			send_mail($to, $email, 'aktivasiiklanpremium');
		}
		$msg = '';
		if( count($stotal) > 0 ){
			$msg .= 'Berhasil mengaktifkan '.count($stotal).' iklan premium<br />';
		}
		if( count($ftotal) > 0 ){
			$msg .= 'Gagal mengaktifkan '.count($ftotal).' iklan premium<br />';
			$msg .= '- '.implode('<br />- ', $ftotal);
		}
		$this->message['text'] = $msg;
		$this->message['class']= 'ok';
		return true;
	}

	function unpublished(){
		$ids = $this->input->post('id');
		$stotal = array();
		$ftotal = array();
		foreach( $ids as $id ){
			$post['enddate'] = 0;
			$r = $this->db->update('iklan_baris', $post, "id=".$this->db->escape($id));
			if( !$r ){
				$ftotal[] = $row->title;
			} else {
				$this->update_tag($id);
				$this->db->delete('iklan2tag', 'iklanid='.$this->db->escape($id));
				$stotal[] = $id;
			}
		}
		
		$msg = '';
		if( count($stotal) > 0 ){
			$msg .= 'Berhasil menonaktifkan '.count($stotal).' iklan premium<br />';
		}
		if( count($ftotal) > 0 ){
			$msg .= 'Gagal menonaktifkan '.count($ftotal).' iklan premium<br />';
			$msg .= '- '.implode('<br />- ', $ftotal);
		}
		$this->message['text'] = $msg;
		$this->message['class']= 'ok';
		return true;
	}
	
	function delete(){
		$ids = $this->input->post('id');
		$stotal = 0;
		$ftotal = 0;
		foreach( $ids as $id ){
			$this->db->select('image');
			$r = $this->db->getwhere('iklan_baris', "id=".$this->db->escape($id));
			$image = $r->get_one();
			
			$r = $this->db->delete('iklan_baris', 'id='.$this->db->escape($id));
			if( $r === false ){
				$ftotal += 1;
			} else {
				$this->update_tag($id);
				$this->db->delete('iklan2tag', 'iklanid='.$this->db->escape($id));
				$this->delete_image($image);
				$stotal += 1;
			}
		}
		
		$msg = '';
		if( $stotal > 0 ){
			$msg .= 'Berhasil menghapus '.$stotal.' iklan.';
		}
		if( $ftotal > 0 ){
			$msg .= 'Gagal menghapus '.$ftotal.' iklan.';
		}
		
		$this->message['text'] = $msg;
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function update_tag($iklanid){
		$this->db->select('tagid');
		$r = $this->db->getwhere('iklan2tag', 'iklanid='.$this->db->escape($iklanid));
		foreach( $r->result() as $row ){
			$sql = "UPDATE ".$this->db->dbprefix."tags SET counter=(counter-1) WHERE tagid=$row->tagid";
			$this->db->simple_query($sql);
		}
	}

	function get_config(){
		$this->db->select();
		$r = $this->db->get('iklan_config');
		$rows = array();
		foreach( $r->result() as $row ){
			$rows[$row->name] = $row;
		}
		return $rows;
	}

	function save_adsconfig(){
		$configs = $this->input->post('adsconfig');
		foreach( $configs as $var => $value ){
			$data['value'] = $value;
			$this->db->update('iklan_config', $data, "name=".$this->db->escape($var));
		}
		
		$this->message['text'] = 'Konfigurasi iklan berhasil disimpan.';
		$this->message['class'] = 'ok';
	}
	
	function delete_image($image='', $id=''){
		if( empty($id) )
			$id = $this->input->post('imagedelid');
		
		if( $id ){
			$this->db->select('image');
			$r = $this->db->getwhere('iklan_baris', "id=".$this->db->escape($id));
			$image = $r->get_one();
			
			if( @unlink(ROOTPATH.'images/iklan/'.$image) === true ){
				$update['image'] = '';
				$this->db->update('iklan_baris', $update, "id=".$this->db->escape($id));
				
				$this->message['text'] = 'Gambar berhasil dihapus';
				$this->message['class'] = 'ok';
			} else {
				$this->message['text'] = 'Gambar gagal dihapus';
				$this->message['class'] = 'error';
			}
		} else {
			@unlink(ROOTPATH.'images/iklan/'.$image);
		}
	}
	
	function get_category_for_list($parentid=0){
		$this->db->select('catid, catname as name');
		$this->db->orderby('catname');
		$r = $this->db->getwhere('kategori_iklan', "parentid=$parentid");

		$rows = array();
		foreach( $r->result() as $row ){
			$row->subcats = $this->get_category_for_list($row->catid);
			$rows[] = $row;
		}
		
		return $rows;
	}
	
	function buttonlist($type='free'){
		$btn = $this->button->start();
		if( current_user_permision('write') === true ){
			$btn .= $this->button->add_button("/backend/ads/add/$type/");
			$btn .= $this->button->separator();
		}
		if( $type=='premium' ){
			if( current_user_permision('modify') === true ){
				$btn .= $this->button->custom_button("cekChecked('published');", 'Aktifkan');
				$btn .= $this->button->separator();
				$btn .= $this->button->custom_button("cekChecked('unpublished');", 'Non-Aktifkan');
				$btn .= $this->button->separator();
			}
		}
		if( current_user_permision('delete') === true ){
				$btn .= $this->button->delete_button();
		}
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function button_add($type){
		$btn = $this->button->start();
		$btn .= $this->button->save_button();
		$btn .= $this->button->separator();
		$btn .= $this->button->cancel_button('/backend/ads/'.$type.'/');
		$btn .= $this->button->end();
		
		return $btn;
	}

	function button_adsconfig(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button();
		$btn .= $this->button->end();
		
		return $btn;
	}

	function _store_tags($tags){
		$this->tags_id = array();
		
		if( !is_array($tags)){
			return false;
		}
		
		foreach( $tags as $tag ){
			$tagslug = url_title($tag);
			$this->db->select('tagid');
			$r = $this->db->getwhere('tags', "slug=".$this->db->escape($tagslug), 1);
			$id = $r->get_one();
			
			if( !$id ){
				$data['tag'] = $tag;
				$data['counter'] = 1;
				$data['slug'] = $tagslug;
				$r = $this->db->insert('tags', $data);
				$id = $this->db->insert_id();
			} else {
				$this->db->select('1');
				$r = $this->db->getwhere('iklan2tag', "tagid=$id AND iklanid=".$this->iklanid, 1);
				$e = $r->get_one();
				if( !$e ){
					$this->db->select('counter');
					$r = $this->db->getwhere('tags', "tagid=$id", 1);
					$counter = $r->get_one();
					$update['counter'] = $counter + 1;
					$r = $this->db->update('tags', $update, "tagid=$id");
				}
			}
			$this->tags_id[] = $id;
		}
	}
	
	function _assign_tags_to_ads(){
		foreach( $this->tags_id as $tag ){
			$this->db->select('1');
			$r = $this->db->getwhere('iklan2tag', "tagid=$tag AND iklanid=".$this->iklanid, 1);
			$e = $r->get_one();
			if( !$e ){
				$data['tagid'] = $tag;
				$data['iklanid'] = $this->iklanid;
				$this->db->insert('iklan2tag', $data);
			}
		}
	}
	
	function get_adsconfig($return=false){
		$this->db->select('name, value');
		$r = $this->db->get('iklan_config');
		if( $return )
			return $r->result();

		foreach( $r->result() as $row ){
			$key = 'ads_'.$row->name;
			$this->config->set_item($key, $row->value);
		}
	}
	
	function _parse_tags($tags, $title){
		$this->tags = array();
		$tags = strip_tags(strtolower($tags));
		if( trim(strip_tags($tags)) == '' ){
			$title = strip_tags(strtolower($title));
			$tags = preg_replace("#\s+#", ',', $title);
		}
		$tags = preg_replace("#[^A-Za-z0-9,\s]#", '', $tags);
		$tags = explode(',', strtolower($tags));
		foreach($tags as $tag){
			$tag = trim(strtolower($tag));
			if( $tag != '' && !in_array($tag, $this->tags)){
				$this->tags[] = $tag;
			}
			
			if( count($this->tags) > 5 )
				break;
		}
		
		array_unique($this->tags);
	}

	function _create_slug($str, $num=1, $ori=''){
		$slug = url_title($str);
		
		if( $ori == '' ){
			$ori = $str;
		}
		
		$this->db->select('id');
		$r = $this->db->getwhere('iklan_baris', "slug=".$this->db->escape($slug));
		$id = $r->get_one();
		if( !$id ){
			return $slug;
		}
		
		$slug = $ori.'-'.$num;
		$num++;
		
		return $this->_create_slug($slug, $num, $ori);
	}

	function _upload_image(){
		$config['upload_path'] = ROOTPATH.'images/iklan/'; 
		$config['allowed_types'] = 'gif|jpg|png';
		$config['encrypt_name'] = false;
		
		$this->load->library('upload', $config);
		
		if( !$this->upload->do_upload('image') ){
			return '';
		}
		
		$d = $this->upload->data();
		
		$config2['source_image'] = $config['upload_path'].$d['file_name'];
		$config2['create_thumb'] = FALSE;
		$config2['maintain_ratio'] = TRUE;
		$config2['width'] = 70;
		$config2['height'] = 70;
		$config2['quality'] = '100';
		$this->load->library('image_lib', $config2);
		if( $this->image_lib->resize() === true )
			return $d['file_name'];
		
		@unlink($config['upload_path'].$d['file_name']);
		
		return '';
	}
	
	function get_ad_status($row){
		$now = gmt_to_local(now(), $this->config->item('time_zone'));
		$datenow = mdate('%Y-%m-%d', $now);
		$timezone = timezones($this->config->item('time_zone')) * 3600;
		
		$startdate = mdate('%Y-%m-%d', gmt_to_local($row->startdate, $this->config->item('time_zone')));
		$enddate = mdate('%Y-%m-%d', gmt_to_local($row->enddate, $this->config->item('time_zone')));
		
		$status = ($startdate<=$datenow && $datenow<=$enddate) ? 'active':(($row->enddate > 0 && $datenow > $enddate) ? 'expired':(($row->startdate > 0 && $row->enddate ==0) ? 'inactive':'new'));
		
		return $status;
	}
}
?>