<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

function category_selector($cats, $def){
	if( !is_array($cats) ){
		return '';
	}
	ob_start();
	foreach( $cats as $cat ){
		?>
		<option value="<?=$cat->catid;?>"<?=$def==$cat->catid ? ' selected="selected"':''; ?><?=count($cat->subcats)>0 ? ' disabled="disabled"':'';?>><?=$cat->name;?></option>
		<?php
		foreach( $cat->subcats as $subcat ){
			?>
			<option value="<?=$subcat->catid;?>"<?=$def==$subcat->catid ? ' selected="selected"':''; ?>>&nbsp;&nbsp;<?=$subcat->name;?></option>
			<?php
		}
	}
	$html = ob_get_contents();
	ob_end_clean();
	return $html;
}

$startdate = mdate('%Y-%m-%d', gmt_to_local($row->startdate, $this->config->item('time_zone')));
$enddate = mdate('%Y-%m-%d', gmt_to_local($row->enddate, $this->config->item('time_zone')));
$status = $this->model->get_ad_status($row);
?>
<script language="javascript" type="text/javascript">
function showprice(obj){
	if( obj.value == 'premium' ){
		document.getElementById('premium-ads').style.display='block';
	} else {
		document.getElementById('premium-ads').style.display='none';
	}
}
</script>
<form method="post" action="" enctype="multipart/form-data" name="admin_form" id="admin_form">
	<input type="hidden" name="id" value="<?=$row->id;?>" />
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="oldstartdate" value="<?=$row->startdate;?>" />
	<input type="hidden" name="oldenddate" value="<?=$row->enddate;?>" />
	<input type="hidden" name="oldlama" value="<?=$row->lama;?>" />
	<input type="hidden" name="oldstatus" value="<?=$status;?>" />
  <table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tbody>
	<tr>
		<td style="width: 23%;">Nama:</td>
		<td><input class="text" name="name" value="<?=$row->name;?>" type="text" maxlength="32" style="width: 350px;" /><br />
		<small>Diperlukan jika Anda memasang iklan premium</small></td>
      	</tr>
	<tr>
		<td>Email:</td>
		<td><input class="text" name="email" value="<?=$row->email;?>" type="text" maxlength="255" style="width: 350px;" /><br />
		<small>Diperlukan jika Anda memasang iklan premium</small></td>
      	</tr>
	<tr>
		<td>Type Iklan:</td>
		<td><?=$type=='free' ? 'Iklan Gratis':'Iklan Premium';?>
		<input type="hidden" name="typeiklan" value="<?=$type;?>" />
		<div id="premium-ads"<?=($type=='premium') ? ' style="display: block;"':' style="display: none;"';?>>
		<p>Lama Langganan: 
		<select name="lama" class="text">
			<?php
			for($i=1; $i<=$this->config->item('ads_maxmonth'); $i++){
				$price = $i * $this->config->item('ads_premiumprice');
				?>
				<option value="<?=$i;?>"<?=$row->lama==$i ? ' selected="selected"':'';?>><?=$i;?> bulan (Rp <?=format_uang($price);?>)</option>
				<?php
			}
			?>
		</select></p>
		<p><small>Harga iklan premium: Rp <?=format_uang($this->config->item('ads_premiumprice'));?> per bulan (30 hari)</small></p>
		</div></td>
      	</tr>
	<?php
	if( $type == 'premium' ){
	?>
	<tr>
		<td>Status</td>
		<td><select name="status">
			<option value="new"<?=$status=='new' ? ' selected="selected"':'';?>>Baru</option>
			<option value="active"<?=$status=='active' ? ' selected="selected"':'';?>>Aktif</option>
			<option value="inactive"<?=$status=='inactive' ? ' selected="selected"':'';?>>Tidak Aktif</option>
			<option value="expired"<?=$status=='expired' ? ' selected="selected"':'';?>>Expired</option>
		</select></td>
	</tr>
	<?php
	}
	?>
	<tr>
		<td>Kategori Iklan *):</td>
		<td><select name="catid" class="text">
			<option value="">Pilih Kategori</option>
			<?=category_selector($cats, $row->catid);?></select></td>
      	</tr>
	<tr>
		<td>Judul Iklan *):</td>
		<td><input  class="text" name="title" value="<?=$row->title;?>" type="text" maxlength="128" style="width: 350px;" /></td>
      	</tr>
      <tr>
        <td>Website:</td>
        <td>http:// <input class="text" name="website" value="<?=$row->website;?>" type="text" style="width: 300px;" /></td>
      </tr>
      <tr>
        <td>Isi Iklan *):</td>
        <td><textarea rows="12" name="content" style="width: 350px;" class="text"><?=$row->content;?></textarea></td>
      </tr>
	  <tr>
        <td>Tags:</td>
        <td><input  class="text" name="tags" value="<?=$row->tags;?>" type="text" maxlength="1000000" style="width: 350px;" /><br /><small>Kata atau phrase yang mewakili iklan Anda, pisahkan dengan koma ( , ).<br />Contoh: <strong>iklan, free ads</strong></small></td>
      </tr>
	   <tr>
        <td>Gambar:</td>
        <td>
		<?php
		if( trim($row->image) != ''){
			?>
			<img src="<?=base_url();?>images/iklan/<?=$row->image;?>" />
			<br />
			<?php
		}
		?>
		<input type="hidden" name="imagetmp" value="<?=$row->image;?>" />
		<input  class="text" name="image" type="file" size="30" style="width: 250px;" />
		<br /><small>File yang diijinkan hanya <strong>gif</strong>, <strong>jpg</strong> dan <strong>png</strong></small></td>
      </tr>
    </tbody>
  </table>
</form>