<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Adsmail_model extends Model {
	function Adsmail_model(){
		parent::Model();
	}

	function send_ads_mail(){
		$this->load->helper('email');
		$intervals = array('7','3','1','0');
		foreach($intervals as $interval){
			$adstotal = $this->get_expired_premium_ads($interval);
			foreach($adstotal as $ads){
				$email['website'] = base_url();
				$email['name'] = $ads->name;
				$email['title'] = $ads->title;
				$email['content'] = $ads->content;
				$email['startdate'] = mdate('%d %F %Y', gmt_to_local($ads->startdate, $this->config->item('time_zone')));
				$email['expired'] = $ads->expired;
				$email['bankdetail'] = nl2br($this->config->item('ads_paymentbank'));
				@send_mail($ads->email, $email, 'expirediklanpremium');
			}		
		}
	}
		
	function load_email($id=''){
		if( empty($id) ){
			$row = $this->input->post_object();
			$row->published = 'Y';
		} else {
			$this->db->select();
			$r = $this->db->getwhere('email_template', "id=$id");
			$row = $r->row();
		}
		
		return $row;
	}


	function get_expired_premium_ads($interval=''){
		$today = mdate('%Y-%m-%d', gmt_to_local(now(), config_item('time_zone')));
		$timezone = timezones(config_item('time_zone')) * 3600;
		$now = now();

		$this->db->select();
		$this->db->orderby('startdate', 'ASC');
		$where = "typeiklan='premium' AND FROM_UNIXTIME((enddate+$timezone),'%Y-%m-%d')=DATE_SUB('$today',INTERVAL $interval DAY)";
		$r = $this->db->getwhere('iklan_baris', $where);
		//$r = $this->db->getwhere('iklan_baris', "typeiklan='premium' AND (startdate<=$now AND enddate>=$now)");
		$rows = array();
		foreach( $r->result() as $row ){
			$this->db->select('t.tag, t.slug');
			$this->db->from(array('tags as t', 'iklan2tag as it'));
			$r2 = $this->db->getwhere('', "t.tagid=it.tagid AND it.iklanid=$row->id");
			$row->tags = $r2->result();
			$row->expired = ($interval > 0) ? "$interval Hari Lagi" : "Hari Ini";

			$this->db->select('slug, catname as name, parentid');
			$r3 = $this->db->getwhere('kategori_iklan', "catid=".$this->db->escape($row->catid));
			$row->cat = $r3->row();
			if( is_object($row->cat) )
				$row->cat->parentslug = $this->get_parent_slug($row->cat->parentid);
			
			$rows[] = $row;
		}

		return $rows;
	}

	function get_parent_slug($catid){
		if( empty($catid) )
			return '';
		
		$this->db->select('slug');
		$r = $this->db->getwhere('kategori_iklan', "catid=".$this->db->escape($catid));
		
		return $r->get_one();
	}

	function get_adsconfig($return=false){
		$this->db->select('name, value');
		$r = $this->db->get('iklan_config');
		if( $return )
			return $r->result();

		foreach( $r->result() as $row ){
			$key = 'ads_'.$row->name;
			$this->config->set_item($key, $row->value);
		}
	}
}
?>