<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Banner extends Controller {
	function Banner(){
		parent::Controller();
		$this->_check_session('backend');
		$this->load->model('Banner_model', 'model');
	}
	
	function index($posisiid=''){
		if( current_user_permision('read') === false )
			noauth();
			
		if( $this->input->post('task') == 'delete' ){
			$this->model->delete();
			$this->session->set_userdata(array('message' => $this->model->_get_message()));
			redirect('/backend/banner/index/');
		}
		
		if( $this->input->post('task') == 'orderup' ){
			$this->model->order('up');
			
			//redirect('/backend/banner/index/');
		}
		if( $this->input->post('task') == 'orderdown' ){
			$this->model->order('down');
			
			//redirect('/backend/banner/index/');
		}
		
		$row['rows'] = $this->model->get_for_list();
		$data['page_title'] = $this->menu->get_page_title();
		$row['posisi'] = $this->model->get_posisi_for_select();
		$row['client'] = $this->model->get_client_for_select();
		$data['message'] = $this->session->userdata('message');
		$this->session->unset_userdata('message');
		$data['button'] = $this->model->button_list();
		$data['html'] = $this->load->cview('dsp-banner-list', $row, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function add(){
		if( current_user_permision('write', '/backend/banner/index/') === false )
			noauth();
		
		$this->edit();
	}
	
	function edit($id=''){
		if( current_user_permision('modify', '/backend/banner/posisi/') === false && $id )
			noauth();
		
		if( $this->input->post('task') == 'save' ){
			if( $this->model->store() === false ){
				$data['message'] = $this->model->_get_message();
			} else {
				$this->session->set_userdata(array('message' => $this->model->_get_message()));
				redirect('/backend/banner/index/');
			}
		}
		
		if( $this->input->post('task') == 'deleteimage' ){
			$image = $this->input->post('imgtodelete');
			$field = $this->input->post('imgfield');
			$pid = $this->input->post('id');
			
			$this->model->delete_image($image, $field, $pid);
			
			redirect('/backend/banner/edit/'.$pid.'/');
		}
		
		$r['row'] = $this->model->get_by_id($id);
		$r['posisi'] = $this->model->get_posisi_for_select();
		$r['client'] = $this->model->get_client_for_select();
		
		$data['page_title'] = $this->menu->get_page_title('/backend/banner/index/').($id ? ' :: Edit':' :: Tambah');
		$data['button'] = $this->model->button_add();
		$data['html'] = $this->load->cview('dsp-banner-form', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function bnrconfig(){
		if( current_user_permision('write') === false || current_user_permision('modify') === false  )
			noauth();

		if( $this->input->post('task') == 'save' ){
			$this->model->save_bnrconfig();
			$data['message'] = $this->model->_get_message();
		}
		
		$r['rows'] = $this->model->get_config();
		$data['page_title'] = $this->menu->get_page_title('', 'backend');
		$data['button'] = $this->model->button_bnrconfig();
		$data['html'] = $this->load->cview('dsp-banner-config', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	/* banner position handler */
	function posisi(){
		if( current_user_permision('read') === false )
			noauth();
			
		if( $this->input->post('task') == 'delete' ){
			$this->model->delete_posisi();
			$this->session->set_userdata(array('message' => $this->model->_get_message()));
			redirect('/backend/banner/posisi/');
		}
		
		$row['rows'] = $this->model->get_posisi_for_list();
		$data['page_title'] = $this->menu->get_page_title('', 'backend');
		$data['message'] = $this->session->userdata('message');
		$this->session->unset_userdata('message');
		$data['button'] = $this->model->button_posisilist();
		$data['html'] = $this->load->cview('dsp-banner-posisi-list', $row, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function posisi_add(){
		if( current_user_permision('write', '/backend/banner/posisi/') === false )
			noauth();
		
		$this->posisi_edit();
	}
	
	function posisi_edit($id=''){
		if( current_user_permision('modify', '/backend/banner/posisi/') === false && $id )
			noauth();
		
		if( $this->input->post('task') == 'save' ){
			if( $this->model->store_posisi() === false ){
				$data['message'] = $this->model->_get_message();
			} else {
				$this->session->set_userdata(array('message' => $this->model->_get_message()));
				redirect('/backend/banner/posisi/');
			}
		}
		
		$this->load->model('template_model', '', 'templatemgr/backend');
		$r['templates'] = $this->template_model->get_templates();
		$r['row'] = $this->model->get_posisi_by_id($id);
		
		$data['page_title'] = $this->menu->get_page_title('/backend/banner/posisi/', 'backend').($id ? ' :: Edit':' :: Tambah');
		$data['button'] = $this->model->button_posisiadd();
		$data['html'] = $this->load->cview('dsp-banner-posisi-form', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	/* Client handler */
	function client(){
		if( current_user_permision('read') === false )
			noauth();
			
		if( $this->input->post('task') == 'delete' ){
			$this->model->delete_client();
			$this->session->set_userdata(array('message' => $this->model->_get_message()));
			redirect('/backend/banner/client/');
		}
		
		$row['rows'] = $this->model->get_client_for_list();
		$data['page_title'] = $this->menu->get_page_title('', 'backend');
		$data['message'] = $this->session->userdata('message');
		$this->session->unset_userdata('message');
		$data['button'] = $this->model->button_clientlist();
		$data['html'] = $this->load->cview('dsp-banner-client-list', $row, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function client_add(){
		if( current_user_permision('write', '/backend/banner/client/') === false )
			noauth();
			
		$this->client_edit();
	}
	
	function client_edit($id=''){
		if( current_user_permision('modify', '/backend/banner/client/') === false && $id )
			noauth();
		
		if( $this->input->post('task') == 'save' ){
			if( $this->model->store_client() === false ){
				$data['message'] = $this->model->_get_message();
			} else {
				$this->session->set_userdata(array('message' => $this->model->_get_message()));
				redirect('/backend/banner/client/');
			}
		}
		
		$r['row'] = $this->model->get_client_by_id($id);
		
		$data['page_title'] = $this->menu->get_page_title('/backend/banner/client/', 'backend').($id ? ' :: Edit':' :: Tambah');
		$data['button'] = $this->model->button_clientadd();
		$data['html'] = $this->load->cview('dsp-banner-client-form', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
}
?>