<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Banner_model extends Model {	
	function Banner_model(){
		parent::Model();
	}
	
	function get_for_list(){
		$this->load->library('pagination');
		
		$posisi = $this->uri->segment(4, 'all');
		$client = $this->uri->segment(5, 'all');
		$status = $this->uri->segment(6, 'all');
		$now = gmt_to_local(now(), $this->config->item('time_zone'));
		
		$where = '1';
		if( $posisi != 'all' ){
			$where .= " AND posisiid=".$this->db->escape($posisi);
		}
		if( $client != 'all' ){
			$where .= " AND cid=".$this->db->escape($client);
		}
		if( $status != 'all' ){
			$where .= " AND IF((startdate<=$now AND $now<=enddate), 'Y', IF((enddate>0 AND $now>enddate), 'E', 'N'))=".$this->db->escape($status);
		}
		
		$this->db->select('COUNT(id)');
		$r = $this->db->getwhere('banners', $where, 1);
		
		$config['base_url'] = $this->uri->slash_segment(1, 'leading').$this->uri->slash_segment(2, 'leading').$this->uri->slash_segment(3, 'both').$posisi.'/'.$client.'/'.$status.'/';
		$config['total_rows'] = $r->get_one();
		$config['per_page'] = 15;
		$config['uri_segment'] = 7;	
		$this->pagination->initialize($config);
		
		$limit = $this->pagination->get_limit();
		$offset = $this->pagination->get_offset();
		
		$this->db->select("*, IF((startdate<=$now AND $now<=enddate), 'Y', IF((enddate>0 AND $now>enddate), 'E', 'N')) as status");
		$this->db->orderby('posisiid');
		$this->db->orderby('startdate');
		$r = $this->db->getwhere('banners', $where, $limit, $offset);
		
		$rows = array();
		foreach( $r->result() as $row ){
			$this->db->select('posisi, width, height');
			$r2 = $this->db->getwhere('banner_position', "posisiid=$row->posisiid");
			$p = $r2->row();
			$row->posisi = $p->posisi.'<br />('.$p->width.' X '.$p->height.')';
			
			$this->db->select();
			$r2 = $this->db->getwhere('banner_client', "cid=$row->cid");
			$row->client = $r2->row();
			
			$rows[] = $row;
		}
		
		return $rows;
	}
	
	function get_by_id($id){
		if( empty($id) ){
			$row = $this->input->post_object();
			$row->lama = 1;
		} else {
			$now = gmt_to_local(now(), $this->config->item('time_zone'));
			$this->db->select("*, IF((startdate<=$now AND $now<=enddate), 'Y', IF((enddate>0 AND $now>enddate), 'E', 'N')) as status");
			$r = $this->db->getwhere('banners', "id=".$this->db->escape($id));
			$row = $r->row();
		}
		
		return $row;
	}
	
	function validate(){
		/*
		$link = $this->input->post('link');
		if( trim($link) == '' ){
			$this->message['text'] = 'Website tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		*/
		$lama = $this->input->post('lama');
		if( intval($lama) < 1 ){
			$this->message['text'] = 'Lama langganan tidak boleh kurang dari 1.';
			$this->message['class'] = 'error';
			return false;
		}
		$customcode =  $this->input->post('bannercode');
		$image_tmp =  $this->input->post('image_tmp');
		if( (!is_uploaded_file($_FILES['image']['tmp_name']) && !$image_tmp) && trim($customcode) == '' ){
			$this->message['text'] = 'Anda harus mengupload banner atau mengisi custom code.';
			$this->message['class'] = 'error';
			return false;
		}
		return true;
	}
	
	function store(){
		if( $this->validate() === false ){
			return false;
		}
		$post['id'] = $this->input->post('id');
		$post['posisiid'] = $this->input->post('posisiid');
		$post['cid'] = $this->input->post('cid');
		$post['link'] = $this->input->post('link');
		$post['lama'] = $this->input->post('lama');
		$post['bannercode'] = $this->input->post('bannercode');
		$post['target'] = $this->input->post('target');
		$post['remarks'] = $this->input->post('remarks');
		$status = $this->input->post('status');
		$oldstatus = $this->input->post('oldstatus');
		
		if( is_uploaded_file($_FILES['image']['tmp_name']) ){
			if( $this->upload_image() === false ){
				return false;
			} else {
				$post['image'] = $this->banner_file;	
				$post['filetype'] = $this->file_type;
			}
		}
		
		if( $post['id'] ){
			return $this->update($post, $status, $oldstatus);
		} else {
			return $this->insert($post, $status, $oldstatus);
		}
	}
	
	function insert($post, $status, $oldstatus){
		$lama = $post['lama'];
		if( $status == 'Y' ){
			$post['startdate'] = now();
			$post['enddate'] = $post['startdate'] + ($lama * 30 * 24 * 60 * 60);
			$sendemail = true;
		}
		
		$r = $this->db->insert('banners', $post);
		if( $r === false ){
			if( !empty($post['image']) )
				$this->delete_image($post['image']);
			
			$this->message['text'] = 'Banner gagal disimpan.';
			$this->message['class'] = 'error';
			return false;
		}
		
		if( $sendemail === true ){
			$this->_send_email($post);
		}
		
		$this->message['text'] = 'Banner berhasil disimpan.';
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function update($post, $status, $oldstatus){
		$id = $post['id'];
		$lama = $post['lama'];
		unset($post['id']);
		$sendemail = false;
		if( $status == 'Y' && ($oldstatus == 'N' || $oldstatus == 'E') ){
			$post['startdate'] = now();
			$post['enddate'] = $post['startdate'] + ($lama * 30 * 24 * 60 * 60);
			$sendemail = true;
		}
		elseif( $status == 'Y' && $oldstatus == 'Y' ){
			$post['startdate'] = $this->input->post('startdate');
			$post['enddate'] = $post['startdate'] + ($lama * 30 * 24 * 60 * 60);
			$sendemail = false;
		}
		else {
			$post['startdate'] = 0;
			$post['enddate'] = 0;
		}
		
		$r = $this->db->update('banners', $post, "id=$id");
		if( $r === false ){
			if( !empty($post['image']) )
				$this->delete_image($post['image']);
			
			$this->message['text'] = 'Banner gagal disimpan.';
			$this->message['class'] = 'error';
			return false;
		}
		
		if( $sendemail === true ){
			$this->_send_email($post);
		}
		
		$this->message['text'] = 'Banner berhasil disimpan.';
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function _send_email($post){
		$this->db->select();
		$r = $this->db->getwhere('banner_client', "cid=".$this->db->escape($post['cid']));
		$client = $r->row();
		
		$email['name'] = $client->name;
		$email['expiredate'] = mdate('%d %F %Y', gmt_to_local($post['enddate'], $this->config->item('time_zone')));
		$email['startdate'] = mdate('%d %F %Y', gmt_to_local($post['startdate'], $this->config->item('time_zone')));
		
		$this->load->helper('email');
		@send_mail($client->email, $email, 'aktivasibanner');
	}
	
	function delete(){
		$ids = $this->input->post('id');
		$ftotal = 0;
		$stotal = 0;
		foreach( $ids as $key => $id ){
			$this->db->select('image');
			$r = $this->db->getwhere('banners', "id=$id");
			$image = $r->get_one();
			
			$r = $this->db->delete('banners', "id=$id");
			if( $r === false ){
				$ftotal++;
			} else {
				$stotal++;
				if( $image )
					$this->delete_image($image);
			}
		}
		
		$msg = '';
		if( $stotal > 0 ){
			$msg .= 'Berhasil menghapus '.$stotal.' data<br />';
		}
		if( $ftotal > 0 ){
			$msg .= 'Gagal menghapus '.$ftotal.' data';
		}
		
		$this->message['text'] = $msg;
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function upload_image(){
		$config['upload_path'] = ROOTPATH.'images/bnrs/'; 
		$config['allowed_types'] = 'gif|jpg|png|swf';
		$config['encrypt_name'] = false;
		
		$this->load->library('upload', $config);
		
		if( !$this->upload->do_upload('image') ){
			$this->message['text'] = $this->upload->display_errors('','');
			$this->message['class'] = 'error';
			return false;
		}
		
		$d = $this->upload->data();
		$this->banner_file = $d['file_name'];
		$this->file_type = $d['file_type'];
		
		return true;
	}
	
	function delete_image($image, $field='', $pid=''){
		$path = ROOTPATH.'images/bnrs/';
		if( is_file($path.$image) )
			@unlink($path.$image);
		
		if( $pid ){
			$update[$field] = '';
			$this->db->update('banners', $update, "id=$pid");
		}
	}
	
	function order($type){
		$ids = $this->input->post('id');
		$ocfg['table'] = 'banners';
		$ocfg['tbl_key'] = 'id';
		$this->ordering->initialize($ocfg);
				
		foreach( $ids as $key => $id ){
			$this->db->select('posisiid');
			$r = $this->db->getwhere('banners', "id=$id", 1);
			$positionid = $r->get_one();
			$this->ordering->set_where('posisiid', $positionid);
			if( $type == 'up' )
				$this->ordering->order_up($id);
			if( $type == 'down' )
				$this->ordering->order_down($id);
		}
		
		return true;
	}
	
	function get_config(){
		$this->db->select();
		$r = $this->db->get('banner_config');
		$rows = array();
		foreach( $r->result() as $row ){
			$rows[$row->name] = $row;
		}
		return $rows;
	}
	
	function save_bnrconfig(){
		$configs = $this->input->post('bnrconfig');
		foreach( $configs as $var => $value ){
			$data['value'] = $value;
			$this->db->update('banner_config', $data, "name=".$this->db->escape($var));
		}
		
		$this->message['text'] = 'Konfigurasi banner berhasil disimpan.';
		$this->message['class'] = 'ok';
	}
	
	function button_add(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button('save', 'true');
		$btn .= $this->button->separator();
		$btn .= $this->button->cancel_button('/backend/banner/index/');
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function button_list(){
		$btn = $this->button->start();
		if( current_user_permision('write') === true ){
			$btn .= $this->button->add_button('/backend/banner/add/');
			$btn .= $this->button->separator();
		}
		if( current_user_permision('delete') === true ){
			$btn .= $this->button->delete_button();
		}
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function button_bnrconfig(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button();
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	/* Banner position model */
	function get_posisi_for_list(){
		$this->db->select();
		$r = $this->db->get('banner_position');
		
		return $r->result();
	}
	
	function get_posisi_by_id($id){
		if( empty($id) ){
			$row = $this->input->post_object();
		} else {
			$this->db->select();
			$r = $this->db->getwhere('banner_position', "posisiid=".$this->db->escape($id));
			$row = $r->row();
		}
		
		return $row;
	}
	
	function get_posisi_for_select(){		
		$template = $this->template->get('name');
		$this->db->select();
		$r = $this->db->getwhere('banner_position', array('template' => $template));
		
		$rows = array();
		$rows['all'] = 'Semua Posisi';
		foreach( $r->result() as $row ){
			$rows[$row->posisiid] = $row->posisi.' ('.$row->width.' X '.$row->height.')';
		}
		
		return $rows;
	}
	
	function validate_posisi(){
		$posisi = $this->input->post('posisi', true);
		if( trim($posisi) == '' ){
			$this->message['text'] = 'Nama posisi tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		$posname = $this->input->post('posname', true);
		if( trim($posname) == '' ){
			$this->message['text'] = 'Nama posisi tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		if( ereg("[^a-zA-Z0-9_]", $posname) ){
			$this->message['text'] = 'Hanya karakter alfabet, numerik, dan underscore (_) yang diperbolehkan untuk nama posisi.';
			$this->message['class'] = 'error';
			return false;
		}
		$width = $this->input->post('width');
		$height = $this->input->post('height');
		if( intval($width) < 1 || intval($height) < 1 ){
			$this->message['text'] = 'Ukuran banner tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		
		return true;
	}
	
	function store_posisi(){
		if( $this->validate_posisi() === false ){
			return false;
		}
		
		$post['posisi'] = $this->input->post('posisi');
		$post['posname'] = $this->input->post('posname');
		$post['width'] = $this->input->post('width');
		$post['height'] = $this->input->post('height');
		$post['price'] = $this->input->post('price');
		$post['maximum'] = intval($this->input->post('maximum'));
		$post['posisiid'] = $this->input->post('id');
		$post['template'] = $this->input->post('template');
		
		if( is_uploaded_file($_FILES['image']['tmp_name']) ){
			$this->upload_image();
			$post['bannerspaceimg'] = $this->banner_file;
		}
		
		if( $post['posisiid'] ){
			return $this->update_posisi($post);
		} else {
			return $this->insert_posisi($post);
		}
	}
	
	function insert_posisi($post){
		$r = $this->db->insert('banner_position', $post);
		if( $r === false ){
			$this->message['text'] = 'Posisi banner gagal disimpan';
			$this->message['class'] = 'error';
			return false;
		}
		$this->message['text'] = 'Posisi banner berhasil disimpan';
		$this->message['class'] = 'ok';
		return true;
	}
	
	function update_posisi($post){
		$id = $post['posisiid'];
		unset($post['posisiid']);
		$r = $this->db->update('banner_position', $post, "posisiid=".$this->db->escape($id));
		if( $r === false ){
			$this->message['text'] = 'Posisi banner gagal disimpan';
			$this->message['class'] = 'error';
			return false;
		}
		$this->message['text'] = 'Posisi banner berhasil disimpan';
		$this->message['class'] = 'ok';
		return true;
	}
	
	function delete_posisi(){
		$ids = $this->input->post('id');
		$ftotal = 0;
		$stotal = 0;
		foreach( $ids as $key => $id ){
			$r = $this->db->delete('banner_position', "posisiid=$id");
			if( $r === false ){
				$ftotal++;
			} else {
				$stotal++;
			}
		}
		
		$msg = '';
		if( $stotal > 0 ){
			$msg .= 'Berhasil menghapus '.$stotal.' data<br />';
		}
		if( $ftotal > 0 ){
			$msg .= 'Gagal menghapus '.$ftotal.' data';
		}
		
		$this->message['text'] = $msg;
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function button_posisiadd(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button('save', 'true');
		$btn .= $this->button->separator();
		$btn .= $this->button->cancel_button('/backend/banner/posisi/');
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function button_posisilist(){
		$btn = $this->button->start();
		if( current_user_permision('write') === true ){
			$btn .= $this->button->add_button('/backend/banner/posisi_add/');
			$btn .= $this->button->separator();
		}
		if( current_user_permision('delete') === true ){
			$btn .= $this->button->delete_button();
		}
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	/* Client */
	function get_client_for_list(){
		$this->db->select();
		$r = $this->db->get('banner_client');
		
		return $r->result();
	}
	
	function get_client_by_id($id){
		if( empty($id) ){
			$row = $this->input->post_object();
		} else {
			$this->db->select();
			$r = $this->db->getwhere('banner_client', "cid=".$this->db->escape($id));
			$row = $r->row();
		}
		
		return $row;
	}
	
	function get_client_for_select(){
		$rows = array();
		$rows['all'] = 'Semua Klien';
		foreach( $this->get_client_for_list() as $row ){
			$rows[$row->cid] = $row->name.' ('.$row->email.')';
		}
		
		return $rows;
	}
	
	function validate_client(){
		$name = $this->input->post('name');
		if( trim($name) == '' ){
			$this->message['text'] = 'Nama tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		
		return true;
	}
	
	function store_client(){
		if( $this->validate_client() === false ){
			return false;
		}
		
		$post['name'] = $this->input->post('name');
		$post['email'] = $this->input->post('email');
		$post['phone'] = $this->input->post('phone');
		$post['cid'] = $this->input->post('id');
		
		if( $post['cid'] ){
			return $this->update_client($post);
		} else {
			return $this->insert_client($post);
		}
	}
	
	function insert_client($post){
		$r = $this->db->insert('banner_client', $post);
		if( $r === false ){
			$this->message['text'] = 'Posisi banner gagal disimpan';
			$this->message['class'] = 'error';
			return false;
		}
		$this->message['text'] = 'Posisi banner berhasil disimpan';
		$this->message['class'] = 'ok';
		return true;
	}
	
	function update_client($post){
		$id = $post['cid'];
		unset($post['cid']);
		$r = $this->db->update('banner_client', $post, "cid=".$this->db->escape($id));
		if( $r === false ){
			$this->message['text'] = 'Posisi banner gagal disimpan';
			$this->message['class'] = 'error';
			return false;
		}
		$this->message['text'] = 'Posisi banner berhasil disimpan';
		$this->message['class'] = 'ok';
		return true;
	}
	
	function delete_client(){
		$ids = $this->input->post('id');
		$ftotal = 0;
		$stotal = 0;
		foreach( $ids as $key => $id ){
			$r = $this->db->delete('banner_client', "cid=$id");
			if( $r === false ){
				$ftotal++;
			} else {
				$stotal++;
			}
		}
		
		$msg = '';
		if( $stotal > 0 ){
			$msg .= 'Berhasil menghapus '.$stotal.' data<br />';
		}
		if( $ftotal > 0 ){
			$msg .= 'Gagal menghapus '.$ftotal.' data';
		}
		
		$this->message['text'] = $msg;
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function button_clientadd(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button('save', 'true');
		$btn .= $this->button->separator();
		$btn .= $this->button->cancel_button('/backend/banner/client/');
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function button_clientlist(){
		$btn = $this->button->start();
		if( current_user_permision('write') === true ){
			$btn .= $this->button->add_button('/backend/banner/client_add/');
			$btn .= $this->button->separator();
		}
		if( current_user_permision('delete') === true ){
			$btn .= $this->button->delete_button();
		}
		$btn .= $this->button->end();
		
		return $btn;
	}
}
?>