<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Banner_model extends Model {	
	function Banner_model(){
		parent::Model();
	}
	
	function get($position, $offset=''){
		$now = gmt_to_local(now(), $this->config->item('time_zone'));
		$datenow = mdate('%Y-%m-%d', $now);
		$timezone = timezones($this->config->item('time_zone')) * 3600;
		
		$template = $this->template->get('name');
		
		$this->db->select();
		$this->db->orderby('startdate', 'ASC');
		$this->db->orderby('viewcouter', 'ASC');
		$this->db->from(array('banners as b', 'banner_position as bp'));
		$r = $this->db->getwhere('', "b.posisiid=bp.posisiid AND bp.posname=".$this->db->escape($position)." AND (startdate + $timezone)<='$now' AND (enddate + $timezone)>='$now' AND bp.template=".$this->db->escape($template), $offset);
		
		$rows = array();
		foreach( $r->result() as $row ){
			$data['viewcouter'] = $row->viewcouter + 1;
			$this->db->update('banners', $data, "id=".$this->db->escape($row->id));
			
			$rows[] = $row;
		}
		
		return $rows;
	}
	
	function get_by_id($id){
		$this->db->select();
		$r = $this->db->getwhere('banners', "id=".$this->db->escape($id));
		
		return $r->row();
	}
	
	function update($row){
		$data['clickcounter'] = $row->clickcounter + 1;
		
		$this->db->update('banners', $data, "id=".$this->db->escape($row->id));
	}
	
	function get_posisi_for_select(){
		$template = $this->template->get('name');
		$this->db->select();
		$this->db->orderby('posisiid');
		$r = $this->db->getwhere('banner_position', array('template' => $template, 'price > ' => 0));
		$rows = array();
		foreach( $r->result() as $row ){
			$rows[$row->posisiid] = $row->posisi.' ('.$row->width.' X '.$row->height.') - Rp '.format_uang($row->price);
		}
		
		return $rows;
	}
	
	function validate(){
		$is_e = false;
		$scode = $this->input->post('scode', true);
		$name = $this->input->post('name', true);
		$email = $this->input->post('email', true);
		$website = $this->input->post('website', true);
		
		$msg = '';
		
		if( trim(strip_tags($name)) == '' ){
			$msg .= 'Nama tidak boleh kosong.<br />';
			$is_e = true;
		}
		if( !preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $email) ){
			$msg .= 'Email yang Anda masukkan tidak valid.<br />';
			$is_e = true;
		}
		if( trim(strip_tags($website)) == '' ){
			$msg .= 'Website tidak boleh kosong.<br />';
			$is_e = true;
		}	
		if( trim(strip_tags($scode)) == '' ){
			$msg .= 'Kode captcha tidak boleh kosong.<br />';
			$is_e = true;
		}
		
		$this->load->library('iwmcaptcha', array('sessvar'=>md5('orderbanner')));
		if( trim(strip_tags($scode)) != '' && $this->iwmcaptcha->Validate($scode) !== true ){
			$msg .= 'Kode captcha tidak valid.<br />';
			$is_e = true;
		}
		
		if( $is_e ){
			$this->message = $msg;
			return false;
		}
		
		return true;
	}
	
	function store(){
		if( $this->validate() === false ){
			return false;
		}
		
		$post['link'] = $this->input->post('website', true);
		$post['remarks'] = $this->input->post('note', true);
		$client['name'] = $this->input->post('name', true);
		$client['email'] = $this->input->post('email', true);
		$post['posisiid'] = $this->input->post('posisiid', true);
		$post['lama'] = $this->input->post('masatayang', true);
		$client['phone'] = $this->input->post('phone', true);
		
		$post['cid'] = $this->_get_client_id($client);
		
		$this->upload_image();
		$post['image'] = $this->banner_file ? $this->banner_file:'';	
		$post['filetype'] = $this->file_type;
		
		$r = $this->db->insert('banners', $post);
		if( !$r ){
			$this->message = 'Order pemasangan banner gagal disimpan.<br />Silahkan hubungi administrator untuk melaporkan hal ini.';
			return false;
		}
		
		$posisi = $this->_get_posisi($post['posisiid']);
		
		$this->load->helper('email');
		$email['name'] = $client['name'];
		$email['masatayang'] = $post['lama'];
		$email['posisi'] = $posisi['desc'];
		$email['totalpayment'] = 'Rp '.format_uang($post['lama'] * $posisi['price']);
		$email['bankdetail'] = nl2br($this->config->item('bnr_paymentbank'));
		
		@send_mail($client['email'], $email, 'orderpasangbanner');
		$msg = 'Terima kasih atas kepercayaan Anda memasang banner di website kami. Silahkan periksa email Anda untuk mengetahui informasi lebih detail.';
		
		$this->message = $msg;
		return true;
	}
	
	function upload_image(){
		$config['upload_path'] = ROOTPATH.'images/bnrs/'; 
		$config['allowed_types'] = 'gif|jpg|png|swf';
		$config['encrypt_name'] = false;
		
		$this->load->library('upload', $config);
		
		if( $this->upload->do_upload('image') ){
			$d = $this->upload->data();
			$this->banner_file = $d['file_name'];
			$this->file_type = $d['file_type'];
		}
		
		return true;
	}
	
	function _get_client_id($client){
		$this->db->select('cid');
		$r = $this->db->getwhere('banner_client', "email=".$this->db->escape($client['email']));
		$cid = $r->get_one();
		if( !$cid ){
			$this->db->insert('banner_client', $client);
			$cid = $this->db->insert_id();
		}
		
		return $cid;
	}
	
	function _get_posisi($posisiid){
		$this->db->select();
		$r = $this->db->getwhere('banner_position', "posisiid=".$this->db->escape($posisiid));
		$row = $r->row();
		
		$p['desc'] = $row->posisi.' ('.$row->width.' X '.$row->height.')';
		$p['price'] = $row->price;
		
		return $p;
	}
	
	function get_banner_config(){
		$this->db->select('name, value');
		$r = $this->db->get('banner_config');
		if( $return )
			return $r->result();

		foreach( $r->result() as $row ){
			$key = 'bnr_'.$row->name;
			$this->config->set_item($key, $row->value);
		}
	}
}
?>