<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Block_model extends Model {	
	function Block_model(){
		parent::Model();
	}
	
	function load_list(){
		$this->db->select();
		$r = $this->db->get('blocks');
		
		return $r->result();
	}
	
	function load($id){
		if( empty($id) ){
			$row = $this->input->post_object();
			$row->published = $this->input->post('published') === false ? 'Y':$this->input->post('published');
		} else {
			$this->db->select();
			$r = $this->db->getwhere('blocks', "id=$id", 1);
			$row = $r->row();
		}
		
		return $row;
	}
	
	function validate(){
		$name = $this->input->post('name');
		if( trim($name) == '' ){
			$this->message['text'] = 'Nama block tidak boleh kosong';
			$this->message['class'] = 'error';
			return false;
		}
		if( ereg("[^a-zA-Z0-9_-]", $name) ){
			$this->message['text'] = 'Hanya karakter alphabet, numeric, underscore (_) dan hyphen (-) yang diijinkan untuk Nama block.';
			$this->message['class'] = 'error';
			return false;
		}
		if( strlen($name) > 20 ){
			$this->message['text'] = 'Nama block terlalu panjang. Panjang maksimal untuk nama block adalah 20 karakter.';
			$this->message['class'] = 'error';
			return false;
		}
		
		return true;
	}
	
	function store(){
		$post['id'] = $this->input->post('id');
		$post['name'] = $this->input->post('name');
		$post['title'] = $this->input->post('title');
		$post['published'] = $this->input->post('published');
		
		if( $post['id'] ){
			return $this->update($post);
		} else {
			return $this->insert($post);
		}
	}
	
	function insert($post){
		$r = $this->db->insert('blocks', $post);
		if( $r === false ){
			$this->message['text'] = 'Block gagal disimpan.';
			$this->message['class'] = 'error';
			return false;
		}
		
		$this->message['text'] = 'Block berhasil disimpan.';
		$this->message['class'] = 'ok';
		return true;
	}
	
	function update($post){
		$id = $post['id'];
		unset($post['id']);
		$r = $this->db->update('blocks', $post, "id=$id");
		if( $r === false ){
			$this->message['text'] = 'Block gagal disimpan.';
			$this->message['class'] = 'error';
			return false;
		}
		
		$this->message['text'] = 'Block berhasil disimpan.';
		$this->message['class'] = 'ok';
		return true;
	}
	
	function published($published){
		$post = $this->input->post('id');
		
		foreach( $post as $key => $id ){
			$r = $this->db->update('blocks', array('published'=>"$published"), "id=$id");
		}
		
		return true;
	}
	
	function delete(){
		$ids = $this->input->post('id');
		$ftotal = 0;
		$stotal = 0;
		foreach( $ids as $key => $id ){
			$r = $this->db->delete('blocks', "id=$id");
			if( $r === false ){
				$ftotal++;
			} else {
				$stotal++;
			}
		}
		
		$msg = '';
		if( $stotal > 0 ){
			$msg .= 'Berhasil menghapus '.$stotal.' data<br />';
		}
		if( $ftotal > 0 ){
			$msg .= 'Gagal menghapus '.$ftotal.' data';
		}
		
		$this->message['text'] = $msg;
		$this->message['class'] = 'ok';
		return true;
	}
	
	function buttonadd(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button('save', 'true');
		$btn .= $this->button->separator();
		$btn .= $this->button->cancel_button('/backend/blockmgr/index/');
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function buttonlist(){
		$btn = $this->button->start();
		if( current_user_permision('write') === true ){
			$btn .= $this->button->add_button('/backend/blockmgr/add/');
			$btn .= $this->button->separator();
		}
		if( current_user_permision('modify') === true ){
			$btn .= $this->button->published_button();
			$btn .= $this->button->separator();
			$btn .= $this->button->unpublished_button();
			$btn .= $this->button->separator();
		}
		if( current_user_permision('delete') === true ){
			$btn .= $this->button->delete_button();
		}
		$btn .= $this->button->end();
		
		return $btn;
	}
}
?>