<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Contact extends Controller {
	function Contact(){
		parent::Controller();
		$this->_check_session('backend');
		$this->load->model('Contact_backend', 'model');
		$this->load->library('Ordering');
	}
	
	function index(){
		if( $this->input->post('task') == 'delete' ){
			$this->model->delete_contact();	
			$msg = $this->model->_get_message();
			$this->session->set_userdata(array('message'=>$msg));		
			redirect('/backend/contact/index/');
		}
		
		$r['rows'] = $this->model->load_contact($contactid) ;
		$data['page_title'] = $this->menu->get_page_title('', 'backend');
		$data['message'] = $this->session->userdata('message');
		$this->session->unset_userdata('message');
		$data['button'] = $this->model->buttonlist_contact();
		$data['html'] = $this->load->cview('contact-index', $r);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function reply($contactid){
		if( $this->input->post('task') == 'send' ){
			$this->model->send_contact();
			$this->model->update_contact();
			$msg = $this->model->_get_message();
			$this->session->set_userdata(array('message'=>$msg));		
			redirect('/backend/contact/index/');
		}
		
		$this->load->plugin('tinymce'); // load tinymce plugins
		$r['row'] = $this->model->load_contact($contactid) ;
		$r['config'] = $this->model->load_address() ;
		$data['page_title'] = 'Reply Contact';
		$data['message'] = $this->session->userdata('message');
		$this->session->unset_userdata('message');
		$data['button'] = $this->model->buttonreply_contact();
		$data['html'] = $this->load->cview('contact-reply', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function setting(){
		if( $this->input->post('task') == 'save' ){
			$this->model->save_contact_setting();	
			$msg = $this->model->_get_message();
		}
		
		$this->load->plugin('tinymce'); // load tinymce plugins
		$r['row'] = $this->model->load_contact_setting() ;
		$data['page_title'] = $this->menu->get_page_title();
		$data['message'] = $msg;
		$data['button'] = $this->model->buttonlist_setting();
		$data['html'] = $this->load->cview('contact-setting', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
}
?>