<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Contact_backend extends Model {
	function Contact_backend(){
		parent::Model();
	}
	
	function load_contact($contactid){
	
		$this->load->library('pagination');
		$this->db->select('COUNT(contactid)');
		$r = $this->db->getwhere('contact');
		
		$config['base_url'] = $this->uri->slash_segment(1, 'leading').$this->uri->slash_segment(2, 'leading').$this->uri->slash_segment(3, 'leading').'/';
		$config['total_rows'] = $r->get_one();
		$config['per_page'] = 20;
		$config['uri_segment'] = 4;	

		$this->pagination->initialize($config);
		
		$limit = $this->pagination->get_limit();
		$offset = $this->pagination->get_offset();

		if( empty($contactid) ){
			$this->db->select("*");
			$this->db->orderby('contactid', 'DESC');
			$r = $this->db->getwhere('contact', '1', $limit, $offset);
			$row = $r->result();
		} else {
			$this->db->select();
			$r = $this->db->getwhere('contact', 'contactid='.$this->db->escape($contactid));
			$row = $r->row();
		}
		
		$this->ordering->set_limit_start($offset);
		$this->ordering->set_numrows($limit);
		
		return $row;
	}

	function load_address(){
			$this->db->select();
			$r = $this->db->getwhere('contact_config', 'id=1');
			$row = $r->row();
	
		return $row;
	}
	
	function load_contact_setting(){
	
		$this->db->select();
		$r = $this->db->getwhere('contact_config', 'id=1');
		$row = $r->row();
		
		return $row;
	}
	
	function buttonlist_contact(){
		$btn = $this->button->start();

		if( current_user_permision('delete') === true ){
			$btn .= $this->button->delete_button('/backend/contact/delete_contact/');
		}
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function buttonreply_contact(){
		$btn = $this->button->start();

		$btn .= $this->button->custom_button("submit_form('send')","Send");
		$btn .= $this->button->separator();		
		$btn .= $this->button->end();
		
		return $btn;
	}

	function buttonlist_setting(){
		$btn = $this->button->start();

		$btn .= $this->button->save_button('save', 'true');
		$btn .= $this->button->separator();
		$btn .= $this->button->end();
		
		return $btn;
	}

	function delete_contact(){
		$contactids = $this->input->post('contactid');
		$ftotal = 0;
		$stotal = 0;
		foreach( $contactids as $key => $contactid ){
			$r = $this->db->delete('contact', "contactid=".$this->db->escape($contactid));
			if( $r === false ){
				$ftotal++;
			} else {
				$stotal++;
			}
		}
		
		$msg = '';
		if( $stotal > 0 ){
			$msg .= 'Berhasil menghapus '.$stotal.' data<br />';
		}
		if( $ftotal > 0 ){
			$msg .= 'Gagal menghapus '.$ftotal.' data';
		}
		
		$this->message['text'] = $msg;
		$this->message['class'] = 'ok';
		return true;
	}

	function send_contact(){
		$mailto		= $this->input->post('mailto');
		$from		= $this->input->post('from');
		$mailfrom	= $this->input->post('mailfrom');
		$content 	= $this->input->post('content');
		
		$this->load->helper('email');
		sendmail($mailto, 'Re : Contact Us', $content, $mailfrom, $from);
	}
	
	function update_contact(){
		$contactid = $this->input->post('contactid');
		$post['replied'] = 'Y' ;
		$post['datereplied'] = now();
		$r = $this->db->update('contact', $post, "contactid=".$this->db->escape($contactid));
		if( $r === false ){
			$this->message['text'] = 'Update & Email Contact gagal.';
			$this->message['class'] = 'error';
			return false;
		}
		
		$this->message['text'] = 'Update & Email Contact berhasil.';
		$this->message['class'] = 'ok';
		return true;	
	}

	function save_contact_setting(){
		
		$post['id'] = $this->input->post('id');
		$post['name'] = $this->input->post('name');
		$post['email'] = $this->input->post('email');
		$post['fulladdress'] = $this->input->post('fulladdress');
		
		$r = $this->db->update('contact_config', $post, "id=".$this->db->escape($post['id']));
		if( $r === false ){
			$this->message['text'] = 'Konfigurasi Contact gagal disimpan.';
			$this->message['class'] = 'error';
			return false;
		}
		
		$this->message['text'] = 'Konfigurasi Contact berhasil disimpan.';
		$this->message['class'] = 'ok';
		return true;
	}
}
?>