<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Cs_model extends Model {	
	function Cs_model(){
		parent::Model();
	}
	
	function validation(){
		$name = $this->input->post('name', true);
		$ymid = $this->input->post('ymid', true);
		
		if( trim($name) == '' ){
			$this->message['text'] = 'Nama menu tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		if( trim($ymid) == '' ){
			$this->message['text'] = 'Page title tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		
		return true;
	}
	
	function load_list(){
		$this->db->select();
		$this->db->orderby('id');
		$r = $this->db->get('customer_support');
		
		return $r->result();
	}
	
	function load($id=''){
		if( empty($id) ){
			$row = $this->input->post_object();
			$row->published = 'Y';
		} else {
			$this->db->select();
			$r = $this->db->getwhere('customer_support', "id=$id");
			$row = $r->row();
		}
		
		return $row;
	}
	
	function store(){
		$post['id'] = $this->input->post('id');
		$post['name'] = $this->input->post('name', true);
		$post['ymid'] = $this->input->post('ymid', true);
		$post['published'] = $this->input->post('published');
		
		if( $post['id'] ){
			return $this->update($post);
		} else {
			return $this->insert($post);
		}
	}
	
	function insert($post){
		$r = $this->db->insert('customer_support', $post);
		if( $r ){
			$this->message['text'] = 'Item berhasil disimpan.';
			$this->message['class'] = 'ok';
			return true;
		} else {
			$this->message['text'] = 'Item GAGAL disimpan<br />'.$this->db->error_message();
			$this->message['class'] = 'error';
			return false;
		}
	}
	
	function update($post){
		$id = $post['id'];
		unset($post['id']);
		
		$r = $this->db->update('customer_support', $post, "id=$id");
		if( $r ){
			$this->message['text'] = 'Item berhasil disimpan.';
			$this->message['class'] = 'ok';
			return true;
		} else {
			$this->message['text'] = 'Item GAGAL disimpan<br />'.$this->db->error_message();
			$this->message['class'] = 'error';
			return false;
		}
	}
	
	function published($published){
		$post = $this->input->post('id');
		foreach( $post as $key => $id ){
			$r = $this->db->update('customer_support', array('published'=>"$published"), "id=$id");
		}
		
		return true;
	}
	
	function delete(){
		$post = $this->input->post('id');
		$ftotal = 0;
		$stotal = 0;
		foreach( $post as $key => $id ){
			$r = $this->db->delete('customer_support', "id=$id");
			if( $r === false ){
				$ftotal++;
			} else {
				$stotal++;
			}
		}
		
		$msg = '';
		if( $stotal > 0 ){
			$msg .= 'Berhasil menghapus '.$stotal.' data<br />';
		}
		if( $ftotal > 0 ){
			$msg .= 'Gagal menghapus '.$ftotal.' data';
		}
		
		$this->message['text'] = $msg;
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function buttonadd(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button('save', 'true');
		$btn .= $this->button->separator();
		$btn .= $this->button->cancel_button('/backend/customersupport/index/');
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function buttonlist(){
		$btn = $this->button->start();
		if( current_user_permision('write') === true ){
			$btn .= $this->button->add_button('/backend/customersupport/add/');
			$btn .= $this->button->separator();
		}
		if( current_user_permision('modify') === true ){
			$btn .= $this->button->published_button();
			$btn .= $this->button->separator();
			$btn .= $this->button->unpublished_button();
			$btn .= $this->button->separator();
		}
		if( current_user_permision('delete') === true ){
			$btn .= $this->button->delete_button();
		}
		$btn .= $this->button->end();
		
		return $btn;
	}
}
?>