<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Et_model extends Model {	
	function Et_model(){
		parent::Model();
	}
	
	function validation(){
		$name = $this->input->post('name', true);
		if( trim($name) == '' ){
			$this->message['text'] = 'Nama menu tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		$subject = $this->input->post('subject', true);
		if( trim($subject) == '' ){
			$this->message['text'] = 'Subject tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		$fulltext = $this->input->post('fulltext');
		if( trim(strip_tags($fulltext)) == '' ){
			$this->message['text'] = 'Content tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		
		return true;
	}
	
	function load_list(){
		$this->db->select();
		$r = $this->db->get('email_template');
		
		return $r->result();
	}
	
	function load($id=''){
		if( empty($id) ){
			$row = $this->input->post_object();
			$row->published = 'Y';
		} else {
			$this->db->select();
			$r = $this->db->getwhere('email_template', "id=$id");
			$row = $r->row();
		}
		
		return $row;
	}
	
	function store(){
		$post['id'] = $this->input->post('id');
		$post['name'] = $this->input->post('name', true);
		$post['subject'] = $this->input->post('subject', true);
		$post['message'] = $this->input->post('fulltext');
		$post['altmessage'] = trim($this->input->post('altmessage'))=='' ? strip_tags($this->input->post('fulltext')):strip_tags($this->input->post('altmessage'));
		$post['senderemail'] = $this->input->post('senderemail', true);
		$post['sendername'] = $this->input->post('sendername', true);
		$post['note'] = $this->input->post('note', true);
		
		if( $post['id'] ){
			return $this->update($post);
		} else {
			return $this->insert($post);
		}
	}
	
	function insert($post){
		$r = $this->db->insert('email_template', $post);
		if( $r ){
			$this->message['text'] = 'Email template berhasil disimpan.';
			$this->message['class'] = 'ok';
			return true;
		} else {
			$this->message['text'] = 'Email template GAGAL disimpan<br />'.$this->db->error_message();
			$this->message['class'] = 'error';
			return false;
		}
	}
	
	function update($post){
		$id = $post['id'];
		unset($post['id']);
		
		$r = $this->db->update('email_template', $post, "id=$id");
		if( $r ){
			$this->message['text'] = 'Email template berhasil disimpan.';
			$this->message['class'] = 'ok';
			return true;
		} else {
			$this->message['text'] = 'Email template GAGAL disimpan<br />'.$this->db->error_message();
			$this->message['class'] = 'error';
			return false;
		}
	}
	
	function delete(){
		$post = $this->input->post('id');
		$ftotal = 0;
		$stotal = 0;
		foreach( $post as $key => $id ){
			$r = $this->db->delete('email_template', "id=$id");
			if( $r === false ){
				$ftotal++;
			} else {
				$stotal++;
			}
		}
		
		$msg = '';
		if( $stotal > 0 ){
			$msg .= 'Berhasil menghapus '.$stotal.' data<br />';
		}
		if( $ftotal > 0 ){
			$msg .= 'Gagal menghapus '.$ftotal.' data';
		}
		
		$this->message['text'] = $msg;
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function buttonadd(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button('save', 'true');
		$btn .= $this->button->separator();
		$btn .= $this->button->cancel_button('/backend/emailtemplate/index/');
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function buttonlist(){
		$btn = $this->button->start();
		if( current_user_permision('write') === true ){
			$btn .= $this->button->add_button('/backend/emailtemplate/add/');
			$btn .= $this->button->separator();
		}
		if( current_user_permision('delete') === true ){
			$btn .= $this->button->delete_button();
		}
		$btn .= $this->button->end();
		
		return $btn;
	}
}
?>