<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Feed extends Controller {
	function Feed(){
		parent::Controller();
		$this->load->model('Feed_model', 'model');
		
		$this->load->helper('string');
		$this->load->helper('text');
	}
	
	function index(){
		$this->rss2();
	}

	function rss2(){
		$this->load->helper('rss_helper');
		$rss_channel = new rssGenerator_channel();
		$rss_channel->title = $this->config->item('sitename');
		$rss_channel->link = site_url();
		$rss_channel->description = $this->config->item('site_title');
		$rss_channel->language = 'en-us';
		$rss_channel->generator = 'IWM RSS Generator';
		
		foreach( $this->model->get_item() as $row) {
			$item = new rssGenerator_item();
			$item->title = $this->fnXmlEncode(strip_tags($row->title));
			$item->description = $this->fnXmlEncode(word_limiter(strip_tags($row->content), 50));
			$item->link = site_url('/iklan/'.$row->slug.'/');
			$item->pubDate = date('D, d M Y H:i:s', $row->created_date).' GMT';
			$item->category = $row->catname;
			$rss_channel->items[] = $item;
		}
		//_print_r($rss_channel->items); die;
		$rss_feed = new rssGenerator_rss();
		$rss_feed->encoding = 'UTF-8';
		$rss_feed->version = '2.0';
		header('Content-Type: text/xml');
		echo $rss_feed->createFeed($rss_channel);
	}

	function fnXmlEncode( $string ) {
		$string = str_replace( "\r\n", "\n", $string );
		$string = preg_replace( '/[\x00-\x08\x0b\x0c\x0e-\x1f]/', '', $string );
		return htmlspecialchars( $string );
	}
}
?>