<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Filemgr_model extends Model {	
	function Filemgr_model(){
		parent::Model();
	}
	
	function load($type, $folder){
		$is_subfolder = false;
		if( !empty($folder) ){
			$is_subfolder = true;
		}
		
		$basepath = ROOTPATH.'userfiles/'.$type.'/';
		$path = $basepath.trim($folder, '/').'/';
		
		$path = rtrim($path, '/').'/';
		
		$folders = array();
		$files = array();
		$d = dir($path);
		while (false !== ($entry = $d->read())) {
			if( $entry == '.' || ($entry == '..' && !$is_subfolder) )
				continue;
			
			if( is_dir($path.$entry) ){
				$fsize = filesize($path.$entry);
				$size = round( $fsize / 1024 );
				$folders[] = 'name="'.$entry.'":|:size="'.$size.'":|:mtime="'.$mtime.'"';
			} else {
				$fsize = filesize($path.$entry);
				$mtime = mdate('%d-%M-%Y %H:%i', filemtime($path.$entry));
				if( $fsize > 0 ){
					$size = round( $fsize / 1024 );
					$files[] = 'name="'.$entry.'":|:size="'.$size.'":|:mtime="'.$mtime.'"';
				}
			}
		}
		$d->close();
		
		natcasesort( $folders ) ;
		natcasesort( $files ) ;
		
		$rows['folders'] = $folders;
		$rows['files'] = $files;
		
		return $rows;
	}
	
	function createfolder($type){
		$curfolder = $this->input->post('curfolder');
		$newfolder = url_title($this->input->post('newfolder'), 'underscore');
		
		if( trim($newfolder) == '' ){
			$this->message['class'] = 'error';
			$this->message['text'] = 'Folder baru tidak boleh kosong atau mengandung karakter yang tidak diijinkan. Hanya karakter a-z0-9 yang diijinkan untuk nama folder.';
			
			return false;
		}
		
		$basepath = ROOTPATH.'userfiles/'.$type.'/';
		$path = $basepath.trim($curfolder, '/').'/'.$newfolder;
		$path = rtrim($path, '/').'/';
		if( is_dir( $path ) ){
			$this->message['class'] = 'error';
			$this->message['text'] = 'Folder <strong>'.$newfolder.'</strong> sudah ada.';
			
			return false;
		}
		
		$oldumask = umask(0) ;
		mkdir( $path, 0777 ) ;
		umask( $oldumask ) ;
		
		$this->message['class'] = 'ok';
		$this->message['text'] = 'Folder <strong>'.$newfolder.'</strong> berhasil dibuat.';
		
		return false;
	}
	
	function upload($type){
		$allowed = array('Image'=> 'gif|jpg|png', 'File' => 'zip|gz|rar|doc|xls|ppt|pdf', 'Flash' => 'swf');
		
		$curfolder = $this->input->post('curfolder');
		$basepath = ROOTPATH.'userfiles/'.$type.'/';
		$path = $basepath.trim($curfolder, '/');
		
		$config['upload_path'] = rtrim($path, '/').'/'; 
		$config['allowed_types'] = $allowed[$type];
		
		$this->load->library('upload', $config);
		if( $this->upload->do_upload('newfile') === false ){
			$this->message['class'] = 'error';
			$this->message['text'] = $this->upload->display_errors('', $close = '<br />');
			return false;
		}
		
		$this->message['class'] = 'ok';
		$this->message['text'] = 'File berhasil diupload.';
		return true;
	}
	
	function delete($type){
		$todels = $this->input->post('id');
		$curfolder = $this->input->post('curfolder');
		$basepath = ROOTPATH.'userfiles/'.$type.'/';
		$path = rtrim($basepath.trim($curfolder, '/').'/');
		
		$is_error = false;
		$count = 0;
		foreach( $todels as $file ){
			
			if( trim($file) == '' || $file == '..' )
				continue;
			
			if( is_dir($path.$file) ){
				if( $this->_is_empty_dir($path.$file) === false ){
					$this->message['class'] = 'error';
					$this->message['text'] = 'Tidak dapat menghapus folder <strong>'.$file.'</strong>. Folder <strong>'.$file.'</strong> tidak kosong.';
					$is_error = true;
					break;
				} else {
					@rmdir($path.$file);
					$count++;
				}
			} else {
				unlink($path.'/'.$file);
				$count++;
			}
		}
		
		if( $is_error === true )
			return false;
		
		$this->message['class'] = 'ok';
		$this->message['text'] = 'Berhasil menghapus <strong>'.$count.'</strong> data.';
		
		return true;
	}
	
	function _is_empty_dir($dir){
		$path = preg_replace("|^(.+?)/*$|", "\\1", $dir).'/';
		
		$d = dir($path);
		while (false !== ($entry = $d->read())) {
			if( $entry == '.' || $entry == '..' )
				continue;
			
			if( is_dir($path.$entry) ){
				return false;
			} 
			elseif( is_file($path.$entry) ) {
				return false;
			}
		}
		$d->close();
		
		return true;
	}
	
	function buttonlist(){
		$btn = $this->button->start();
		$btn .= $this->button->custom_button("resize_container(); cekDel('delete');", "Delete");
		$btn .= $this->button->end();
		
		return $btn;
	}
}
?>