<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Links extends Controller {
	function Links(){
		parent::Controller();
		$this->_check_session('backend');
		$this->load->model('Links_model', 'model');
	}
	
	function index($posisiid=''){
		if( current_user_permision('read') === false )
			noauth();
		
		$data['message'] = $this->session->userdata('message');
		$this->session->unset_userdata('message');
			
		if( $this->input->post('task') == 'delete' ){
			$this->model->delete();
			$this->session->set_userdata(array('message' => $this->model->_get_message()));
		}
		
		$data['page_title'] = $this->menu->get_page_title();
		$row['rows']		= $this->model->get_links();
		$row['status']		= $this->model->get_status_for_select();
		$data['button'] 	= $this->model->button_list();
		$data['html'] 		= $this->load->cview('dsp-links-list', $row, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function add(){
		if( current_user_permision('write', '/backend/links/index/') === false )
			noauth();
		
		$this->edit();
	}
	
	function edit($id=''){
		if( current_user_permision('modify', '/backend/links/index/') === false && $id )
			noauth();
		
		if( $this->input->post('task') == 'save' ){
			if( $this->model->store() === false ){
				$data['message'] = $this->model->_get_message();
			} else {
				$this->session->set_userdata(array('message' => $this->model->_get_message()));
				redirect('/backend/links/index/');
			}
		}
		
		$r['row'] 			= $this->model->get_link($id);
		$r['status']		= $this->model->get_status_for_select();
		$data['page_title'] = $this->menu->get_page_title('/backend/links/index/').($id ? ' :: Edit':' :: Tambah');
		$data['button'] 	= $this->model->button_add();
		$data['html'] 		= $this->load->cview('dsp-links-form', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function links_config(){
		if( current_user_permision('write') === false || current_user_permision('modify') === false  )
			noauth();

		if( $this->input->post('task') == 'save' ){
			$this->model->save_config();
			$data['message'] = $this->model->_get_message();
		}
		
		$r['rows'] = $this->model->get_config();
		$data['page_title'] = $this->menu->get_page_title();
		$data['html'] = $this->load->cview('dsp-links-config', $r, true);
		$data['button'] = $this->model->button_config();
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
}
?>