<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Links_model extends Model {	
	function Links_model(){
		parent::Model();
	}
	
	function get_links(){
		$this->load->library('pagination');
		
		$status 		= $this->uri->segment(4, 'all');
		$now 			= gmt_to_local(now(), $this->config->item('time_zone'));
		$today			= mdate('%Y-%m-%d', $now);
		$timezone 		= timezones($this->config->item('time_zone')) * 3600;
		$keyword 		= $this->input->post('q');
		$from_session 	= false;
		if( !$keyword ){
			$keyword = $this->session->userdata($this->uri->segment(5));
			$from_session = true;
		}
		
		$where = "1=1";
		if( 'all' != $status ){
			$where .= " AND IF( (FROM_UNIXTIME(start_date + $timezone, '%Y-%m-%d') <= '$today' AND '$today' <= FROM_UNIXTIME(end_date + $timezone, '%Y-%m-%d')), 'published', IF( (end_date > 0 AND $today > FROM_UNIXTIME(end_date + $timezone, '%Y-%m-%d')), 'expire', IF( (start_date > 0 AND end_date = 0), 'unpublished', 'new' ) ) ) = ".$this->db->escape($status);
		}
		if( $keyword ){
			$where .= " AND (anchor LIKE ".$this->db->escape('%'.$keyword.'%')." OR link LIKE ".$this->db->escape('%'.$keyword.'%')." OR name LIKE ".$this->db->escape('%'.$keyword.'%')." OR email LIKE ".$this->db->escape('%'.$keyword.'%').")";
			if( $from_session === false )
				$this->session->set_userdata(array('search' => $keyword));
		}
		
		$this->db->select('COUNT(leid)');
		$r = $this->db->getwhere('links', $where, 1);
		
		$config['base_url'] = $this->uri->slash_segment(1, 'leading').$this->uri->slash_segment(2, 'leading').$this->uri->slash_segment(3, 'both').$status.'/'.($keyword ? 'search/':'');
		$config['total_rows'] = $r->get_one();
		$config['per_page'] = 20;
		$config['uri_segment'] = $keyword ? 6:5;	
		$this->pagination->initialize($config);
		
		$limit = $this->pagination->get_limit();
		$offset = $this->pagination->get_offset();
		
		$this->db->select("*,IF( (FROM_UNIXTIME(start_date + $timezone, '%Y-%m-%d') <= '$today' AND '$today' <= FROM_UNIXTIME(end_date + $timezone, '%Y-%m-%d')), 'published', IF( (end_date > 0 AND $today > FROM_UNIXTIME(end_date + $timezone, '%Y-%m-%d')), 'expire', IF( (start_date > 0 AND end_date = 0), 'unpublished', 'new' ) ) ) as status");
		$this->db->orderby('leid', 'DESC');
		$r = $this->db->getwhere('links', $where, $limit, $offset);

		return $r->result();
	}
	
	function get_link($id){
		if( empty($id) ){
			$row = $this->input->post_object();
		} else {
			$now 		= gmt_to_local(now(), $this->config->item('time_zone'));
			$today		= mdate('%Y-%m-%d', $now);
			$timezone 	= timezones($this->config->item('time_zone')) * 3600;
			$this->db->select("*, IF( (FROM_UNIXTIME(start_date + $timezone, '%Y-%m-%d') <= '$today' AND '$today' <= FROM_UNIXTIME(end_date + $timezone, '%Y-%m-%d')), 'published', IF( (end_date > 0 AND $today > FROM_UNIXTIME(end_date + $timezone, '%Y-%m-%d')), 'expire', IF( (start_date > 0 AND end_date = 0), 'unpublished', 'new' ) ) ) as status");
			$r = $this->db->getwhere('links', array("leid" => $id));
			$row = $r->row();
		}
		
		return $row;
	}
	
	function validate(){
		$anchor = $this->input->post('anchor');
		if( trim($anchor) == '' ){
			$this->message['text'] = 'Teks Anchor tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		 
		$link = $this->input->post('link');
		if( trim($link) == '' ){
			$this->message['text'] = 'Website tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		$name = $this->input->post('name');
		if( trim($name) == '' ){
			$this->message['text'] = 'Nama tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		$email = $this->input->post('email');
		if( trim($email) == '' ){
			$this->message['text'] = 'Email tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		if( !preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $email) ){
			$this->message['text'] = 'Email yang Anda masukkan tidak valid.';
			$this->message['class'] = 'error';
			return false;
		}
		
		return true;
	}
	
	function store(){
		if( $this->validate() === false ){
			return false;
		}
		$post['leid'] 	= $this->input->post('leid');
		$post['anchor'] = strip_tags($this->input->post('anchor'));
		$post['link'] 	= $this->input->post('link');
		$post['name'] 	= $this->input->post('name');
		$post['email'] 	= $this->input->post('email');
		$post['phone'] 	= $this->input->post('phone');
		$post['period'] = $this->input->post('period');
		$status 		= $this->input->post('status');
		
		$sendmail = false;
		if( $post['leid'] ){
			$l = $this->get_link($post['leid']);
			if( 'published' == $status && ('new' == $l->status || 'expire' == $l->status) ){
				$post['start_date'] = now();
				if( 'expire' == $l->status && $l->end_date > $post['start_date'] ){
					$post['start_date'] = $l->end_date;
				}
				$post['end_date']	= strtotime("+".$post['period']." month", $post['start_date']);
				$sendmail = true;
			}
			elseif( 'published' == $status && 'unpublished' == $l->status ){
				$post['end_date']	= strtotime("+".$post['period']." month", $l->start_date);
			}
			elseif( 'unpublished' == $status && 'published' == $l->status ){
				$post['end_date'] = 0;
			}
			
			$r = $this->update($post);
		} else {
			if( 'published' == $status ){
				$post['start_date'] = now();
				$post['end_date']	= strtotime("+".$post['period']." month", $post['start_date']);
				$sendmail = true;
			}
			$r = $this->insert($post);
		}
		
		if( $r && $sendmail ){
			$post['tanggal_expire'] = mdate('%d %F %Y', $post['end_date']);
			
			$this->load->helper('email');
			send_mail($post['email'], $post, 'aktivasilink');
		}
		
		return $r;
	}
	
	function insert($post){
		$r = $this->db->insert('links', $post);
		if( $r === false ){			
			$this->message['text'] = 'Link gagal disimpan.';
			$this->message['class'] = 'error';
			return false;
		}
		
		$this->message['text'] = 'Link berhasil disimpan.';
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function update($post){
		$id = $post['leid'];
		unset($post['leid']);
		
		$r = $this->db->update('links', $post, "leid=$id");
		if( $r === false ){			
			$this->message['text'] = 'Link gagal disimpan.';
			$this->message['class'] = 'error';
			return false;
		}
		
		$this->message['text'] = 'Link berhasil disimpan.';
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function delete(){
		$ids = $this->input->post('id');
		$ftotal = 0;
		$stotal = 0;
		foreach( $ids as $key => $id ){
			$r = $this->db->delete('links', "leid=$id");
			if( $r === false ){
				$ftotal++;
			} else {
				$stotal++;
			}
		}
		
		$msg = '';
		if( $stotal > 0 ){
			$msg .= 'Berhasil menghapus '.$stotal.' data<br />';
		}
		if( $ftotal > 0 ){
			$msg .= 'Gagal menghapus '.$ftotal.' data';
		}
		
		$this->message['text'] = $msg;
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function button_add(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button('save', 'true');
		$btn .= $this->button->separator();
		$btn .= $this->button->cancel_button('/backend/links/index/');
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function button_list(){
		$btn = $this->button->start();
		if( current_user_permision('write') === true ){
			$btn .= $this->button->add_button('/backend/links/add/');
			$btn .= $this->button->separator();
		}
		if( current_user_permision('delete') === true ){
			$btn .= $this->button->delete_button();
		}
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function get_config(){
		$this->db->select();
		$r = $this->db->get('link_config');
		$rows = array();
		foreach( $r->result() as $row ){
			$rows[$row->name] = $row;
		}
		return $rows;
	}
	
	function save_config(){
		$configs = $this->input->post('linkconfig');
		foreach( $configs as $var => $value ){
			$data['value'] = $value;
			$this->db->update('link_config', $data, "name=".$this->db->escape($var));
		}
		
		$this->message['text'] = 'Konfigurasi berhasil disimpan.';
		$this->message['class'] = 'ok';
	}
	
	function button_config(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button();
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function get_status_for_select(){
		$status = array(
			'new' 			=> 'Baru',
			'published' 	=> 'Aktif',
			'unpublished' 	=> 'Non Aktif',
			'expire'		=> 'Expire'
		);
		
		return $status;
	}
}
?>