<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Links_model extends Model {	
	function Links_model(){
		parent::Model();
		$this->_get_link_config();
	}
	
	function gets(){
		$now 		= gmt_to_local(now(), $this->config->item('time_zone'));
		$today		= mdate('%Y-%m-%d', $now);
		$timezone 	= timezones($this->config->item('time_zone')) * 3600;
		
		$this->db->select();
		$this->db->orderby('start_date');
		$r = $this->db->getwhere('links', "FROM_UNIXTIME(start_date + $timezone, '%Y-%m-%d') <= '$today' AND '$today' <= FROM_UNIXTIME(end_date + $timezone, '%Y-%m-%d')");
		
		return $r->result();
	}
	
	function validate(){
		$anchor = $this->input->post('anchor');
		if( trim($anchor) == '' ){
			$this->message = 'Teks Anchor tidak boleh kosong.';
			return false;
		}
		if( strlen($anchor) > $this->config->item('link_maxanchor') ){
			$this->message = sprintf('Teks Anchor terlalu panjang. Teks anchor maksimal %d karakter.', $this->config->item('link_maxanchor'));
			return false;
		}
		$link = $this->input->post('link');
		if( trim($link) == '' ){
			$this->message = 'Website tidak boleh kosong.';
			return false;
		}
		$period = intval($this->input->post('period'));
		if( $period <= 0 ){
			$this->message = 'Lama pemasangan tidak boleh kosong atau kurang dari 1.';
			return false;
		}
		$name = $this->input->post('name');
		if( trim($name) == '' ){
			$this->message = 'Nama tidak boleh kosong.';
			return false;
		}
		$email = $this->input->post('email');
		if( trim($email) == '' ){
			$this->message = 'Email tidak boleh kosong.';
			return false;
		}
		if( !preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $email) ){
			$this->message = 'Email yang Anda masukkan tidak valid.';
			return false;
		}
		
		$scode = $this->input->post('scode', true);
		if( trim(strip_tags($scode)) == '' ){
			$this->message = 'Kode captcha tidak boleh kosong.';
			return false;
		}
		
		$this->load->library('iwmcaptcha', array('sessvar' => md5('orderlink')));
		if( $this->iwmcaptcha->Validate($scode) !== true ){
			$this->message = 'Kode captcha tidak valid.';
			return false;
		}
		
		return true;
	}
	
	function store(){
		if( $this->validate() === false ){
			return false;
		}
		
		$post['anchor'] = strip_tags($this->input->post('anchor'));
		$post['link'] 	= $this->input->post('link');
		$post['name'] 	= strip_tags($this->input->post('name'));
		$post['email'] 	= $this->input->post('email');
		$post['phone'] 	= $this->input->post('phone');
		$post['period'] = $this->input->post('period');
		
		$r = $this->db->insert('links', $post);
		
		if( !$r ){
			$this->message = 'Order pemasangan link gagal disimpan. Silahkan coba lain waktu.';
			return false;
		}
		
		$post['biaya'] 			= 'Rp '.format_uang($post['period'] * $this->config->item('link_price'));
		$post['period'] 		= $post['period'].' bulan';
		$post['banktransfer']	= nl2br($this->config->item('link_paymentbank'));
		
		$this->load->helper('email');
		@send_mail($post['email'], $post, 'orderlink');
		
		$this->message = 'Order pemasangan link berhasil disimpan. Silahkan lakukan pembayaran sebesar '.$post['biaya'].' ke salah satu rekening berikut<br /><br />'.$post['banktransfer'];
		
		return true;
	}
	
	function _get_link_config(){
		$this->db->select('name, value');
		$r = $this->db->get('link_config');

		foreach( $r->result() as $row ){
			$key = 'link_'.$row->name;
			$this->config->set_item($key, $row->value);
		}
	}
}
?>