<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Menu_model extends Model {	
	function Menu_model(){
		parent::Model();
	}
	
	function validation(){
		$post['name'] = $this->input->post('name');
		$post['link'] = $this->input->post('link');
		
		if( trim($post['name']) == '' ){
			$this->message['text'] = 'Nama menu tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		$pagetitle = $this->input->post('pagetitle');
		if( trim($pagetitle) == '' ){
			$this->message['text'] = 'Judul halaman tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		
		if( trim($post['link']) == '' ){
			$this->message['text'] = 'Link tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		
		return true;
	}
	
	function loadlist($type, $parentid=0, $ordersegment=6){
		$this->load->library('pagination');
		
		$this->db->select('COUNT(id)');
		$r = $this->db->getwhere('menus', "menutype='$type' AND parentid=$parentid", 1);
		
		$config['base_url'] = $this->uri->slash_segment(1, 'leading').$this->uri->slash_segment(2, 'leading').$this->uri->slash_segment(3, 'leading').$this->uri->slash_segment(4, 'both').$parentid.'/';
		$config['total_rows'] = $r->get_one();
		$config['per_page'] = 20;
		$config['uri_segment'] = $ordersegment;	
		$this->pagination->initialize($config);
		
		$limit = $this->pagination->get_limit();
		$offset = $this->pagination->get_offset();
		
		$this->db->select();
		$this->db->orderby('positionid');
		$this->db->orderby('ordering');
		$r = $this->db->getwhere('menus', "menutype='$type' AND parentid=$parentid", $limit, $offset);
		$rows =  $r->result();
		
		$this->ordering->set_limit_start($offset);
		$this->ordering->set_numrows($limit);
		return $rows;
	}
	
	function load($id){
		if( empty($id) ){
			$row = $this->input->post_object();
			$row->published = $this->input->post('published') === false ? 'Y':$this->input->post('published');
		} else {
			$this->db->select();
			$r = $this->db->getwhere('menus', "id=$id", 1);
			$row = $r->row();
		}
		
		return $row;
	}
	
	function loadall($menutype, $parentid=0){
		$this->db->select('id, name');
		$this->db->orderby('ordering');
		$r = $this->db->getwhere('menus', "menutype='$menutype' AND parentid=$parentid");
		if( $r === false )
			return array();
		
		$rows = array();
		foreach( $r->result() as $row ){
			$row->submenu = $this->loadall($menutype, $row->id);
			$rows[] = $row;
		}
		
		return $rows;
	}
	
	function store(){
		$post['id'] = $this->input->post('id');
		$post['parentid'] = $this->input->post('parentid');
		$post['name'] = $this->input->post('name');
		$post['menutype'] = $this->input->post('menutype');
		$post['published'] = $this->input->post('published');
		$post['access'] = $this->input->post('access');
		$post['link'] = $this->input->post('link');
		$post['positionid'] = $this->input->post('positionid');
		$post['pagetitle'] = $this->input->post('pagetitle');
		
		if( $post['id'] ){
			return $this->update($post);
		} else {
			return $this->insert($post);
		}
	}
	
	function insert($post){
		$this->db->select('ordering');
		$this->db->orderby('ordering', 'DESC');		
		$r = $this->db->getwhere('menus', "parentid=".$post['parentid']." AND menutype='".$post['menutype']."' AND positionid='".intval($post['positionid'])."'", 1);		
		$last_ordering = $r->get_one();
		$last_ordering = $last_ordering === false ? 0:$last_ordering;
		$next_ordering = $last_ordering + 1;
		
		$data['name'] = $post['name'];
		$data['link'] = $post['link'];
		$data['access'] = isset($post['access']) ? $post['access']:'0';
		$data['published'] = isset($post['published']) ? $post['published']:'N';
		$data['menutype'] = $post['menutype'];
		$data['ordering'] = $next_ordering;
		$data['parentid'] = $post['parentid'];
		$data['positionid'] = $post['positionid'];
		$data['pagetitle'] = $post['pagetitle'];
		
		$r = $this->db->insert('menus', $data);
		if( $r === false ){
			$this->message['text'] = 'Menu gagal disimpan';
			$this->message['class'] = 'error';
			return false;
		}
		$this->message['text'] = 'Menu berhasil disimpan';
		$this->message['class'] = 'ok';
		return true;
	}
	
	function update($post){
		$data['name'] = $post['name'];
		$data['link'] = $post['link'];
		$data['access'] = isset($post['access']) ? $post['access']:'0';
		$data['published'] = isset($post['published']) ? $post['published']:'N';
		$data['menutype'] = $post['menutype'];
		$data['parentid'] = $post['parentid'];
		$data['positionid'] = $post['positionid'];
		$data['pagetitle'] = $post['pagetitle'];
		$id = $post['id'];
		
		$this->db->select('positionid, ordering, parentid');
		$r = $this->db->getwhere('menus', "id=$id", 1);
		$old = $r->row();
		if( $old->positionid != intval($data['positionid']) || $old->parentid != $data['parentid'] ){
			$this->db->select('ordering');
			$this->db->orderby('ordering', 'DESC');
			$r = $this->db->getwhere('menus', "parentid=".$data['parentid']." AND menutype='".$data['menutype']."' AND positionid=".intval($data['positionid']), 1);		
			$last_ordering = $r->get_one();
			$last_ordering = $last_ordering === false ? 0:$last_ordering;
			$next_ordering = $last_ordering + 1;
			$data['ordering'] = $next_ordering;
		}
		
		$r = $this->db->update('menus', $data, "id=$id");
		if( $r === false ){
			$this->message['text'] = 'Menu gagal disimpan';
			$this->message['class'] = 'error';
			return false;
		}
		
		if( $old->positionid != intval($data['positionid']) || $old->parentid != $data['parentid'] ){
			$this->db->select('id, ordering');
			$this->db->orderby('ordering');
			if( $old->positionid != intval($data['positionid']) )
				$r = $this->db->getwhere('menus', "positionid=$old->positionid AND ordering>$old->ordering");
			if( $old->parentid != $data['parentid'] )
				$r = $this->db->getwhere('menus', "parentid=$old->parentid AND ordering>$old->ordering");
			
			foreach( $r->result() as $row ){
				$new['ordering'] = $row->ordering - 1;
				$this->db->update('menus', $new, "id=$row->id");
			}
		}
		
		$this->message['text'] = 'Menu berhasil disimpan';
		$this->message['class'] = 'ok';
		return true;
	}
	
	function published($published){
		$post = $this->input->post('id');
		
		foreach( $post as $key => $id ){
			$r = $this->db->update('menus', array('published'=>"$published"), "id=$id");
		}
		
		return true;
	}
	
	function order($type){
		$menutype = $this->input->post('menutype');
		$parentid = $this->input->post('parentid');
		$ids = $this->input->post('id');
		$ocfg['table'] = 'menus';
		$ocfg['tbl_key'] = 'id';
		$this->ordering->initialize($ocfg);
		$this->ordering->set_where('menutype', $menutype);
		$this->ordering->set_where('parentid', $parentid);
				
		foreach( $ids as $key => $id ){
			$this->db->select('positionid');
			$r = $this->db->getwhere('menus', "id=$id", 1);
			$positionid = $r->get_one();
			$this->ordering->set_where('positionid', $positionid);
			if( $type == 'up' )
				$this->ordering->order_up($id);
			if( $type == 'down' )
				$this->ordering->order_down($id);
		}
		
		return true;
	}
	
	function delete(){
		$ids = $this->input->post('id');
		$ftotal = 0;
		$stotal = 0;
		foreach( $ids as $key => $id ){
			$r = $this->db->delete('menus', "id=$id");
			if( $r === false ){
				$ftotal++;
			} else {
				$stotal++;
			}
		}
		
		$msg = '';
		if( $stotal > 0 ){
			$msg .= 'Berhasil menghapus '.$stotal.' data<br />';
		}
		if( $ftotal > 0 ){
			$msg .= 'Gagal menghapus '.$ftotal.' data';
		}
		
		$this->message['text'] = $msg;
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function load_position(){
		$this->db->select();
		$r = $this->db->get('menu_position');
		
		return $r->result();
	}
	
	function store_position(){
		$position = strtolower($this->input->post('position', true));
		if( !empty($position) ){
			$this->db->select('positionid');
			$r = $this->db->getwhere('menu_position', "position='$position'");
			if( $r->num_rows() == 0 ){
				$data['position'] = $position;
				$this->db->insert('menu_position', $data);
			}
		}
		
		return true;
	}
	
	function delete_position(){
		$ids = $this->input->post('id');
		$ftotal = 0;
		$stotal = 0;
		foreach( $ids as $key => $id ){
			$r = $this->db->delete('menu_position', "positionid=$id");
			if( $r === false ){
				$ftotal++;
			} else {
				$stotal++;
			}
		}
		
		$msg = '';
		if( $stotal > 0 ){
			$msg .= 'Berhasil menghapus '.$stotal.' data<br />';
		}
		if( $ftotal > 0 ){
			$msg .= 'Gagal menghapus '.$ftotal.' data';
		}
		
		$this->message = $msg;
		
		return true;
	}
	
	function buttonlist($type, $parentid){
		$btn = $this->button->start();
		if( current_user_permision('write') === true ){
			$btn .= $this->button->add_button("/backend/menumgr/add/$type/$parentid/");
			$btn .= $this->button->separator();
			if( $type == 'frontend' ){
				$btn .= $this->button->custom_button("load_page('".site_url2('/backend/menumgr/position/')."');", "Group Menu");
				$btn .= $this->button->separator();
			}
		}
		if( current_user_permision('modify') === true ){
			$btn .= $this->button->published_button();
			$btn .= $this->button->separator();
			$btn .= $this->button->unpublished_button();
			$btn .= $this->button->separator();
		}
		if( current_user_permision('delete') === true ){
			$btn .= $this->button->delete_button();
		}
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function buttonadd($type, $parentid){
		$btn = $this->button->start();
		$btn .= $this->button->save_button('save');
		$btn .= $this->button->separator();
		$btn .= $this->button->cancel_button("/backend/menumgr/index/$type/$parentid/");
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function buttonposition(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button('save');
		$btn .= $this->button->separator();
		$btn .= $this->button->delete_button();
		$btn .= $this->button->separator();
		$btn .= $this->button->custom_button("load_page('".site_url2('/backend/menumgr/index/frontend/')."');", "Kembali ke Kelola Menu");
		$btn .= $this->button->end();
		
		return $btn;
	}
}
?>