<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Page extends Controller {
	function Page() {
		parent::Controller();
		$this->_check_session('backend');
		$this->load->model('Page_model', 'model');
	}
	
	function index(){
		if( current_user_permision('read', '/backend/page/index/') === false )
			noauth();
		
		if( $this->input->post('task') == 'published' ){
			$this->model->published('Y');
			redirect('/backend/page/index/');
		}
		
		if( $this->input->post('task') == 'unpublished' ){
			$this->model->published('N');
			redirect('/backend/page/index/');
		}
		
		if( $this->input->post('task') == 'delete' ){
			$this->model->delete();
			$this->session->set_userdata(array('message'=>$this->model->_get_message()));
			redirect('/backend/page/index/');
		}
		
		$row['rows'] = $this->model->load_list();
		$data['page_title'] = 'Daftar Halaman Statis';
		$data['message'] = $this->session->userdata('message');
		$this->session->unset_userdata('message');
		$data['html'] = $this->load->cview('pagelist', $row, true);
		$data['button'] = $this->model->pagelist();
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function add(){
		if( current_user_permision('write', '/backend/page/index/') === false )
			noauth();
		
		$this->edit('');
	}
	
	function edit($id){
		if( current_user_permision('modify', '/backend/page/index/') === false && $id )
			noauth();
		
		if( $this->input->post('task') == 'save' ){
			if( $this->model->validation() === false ){
				$data['message'] = $this->model->_get_message();
			}
			elseif( $this->model->store() === false ){
				$data['message'] = $this->model->_get_message();
			}
			else {
				$msg = $this->model->_get_message();
				$this->session->set_userdata(array('message'=>$msg));
				redirect('/backend/page/index/');
			}
		}
		$this->load->plugin('tinymce'); // load tinymce plugins
		$r['row'] = $this->model->load($id);
		$data['page_title'] = @$id ? 'Edit Halaman':'Tambah Halaman';
		$data['button'] = $this->model->pageadd();
		$data['html'] = $this->load->cview('pageform', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function welcomemsg(){
		if( $this->input->post('task') == 'save' ){
			if( $this->model->validation() === false ){
				$data['message'] = $this->model->_get_message();
			}
			elseif( $this->model->store() === false ){
				$data['message'] = $this->model->_get_message();
			}
			else {
				$msg = $this->model->_get_message();
				$this->session->set_userdata(array('message'=>$msg));
				redirect('/backend/page/welcomemsg/');
			}
		}
		$this->load->plugin('tinymce'); // load tinymce plugins
		$r['row'] = $this->model->load_by_slug('welcome-message');
		$data['page_title'] = 'Edit Welcome Message';
		$data['button'] = $this->model->button_wm();
		$data['message'] = $this->session->userdata('message');
		$this->session->unset_userdata('message');
		$data['html'] = $this->load->cview('wm-form', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
}
?>