<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Page_model extends Model {	
	function Page_model(){
		parent::Model();
	}
	
	function validation(){
		$name = $this->input->post('name', true);
		$title = $this->input->post('title', true);
		$fulltext = $this->input->post('fulltext');
		$menuid = $this->input->post('menuid');
		
		if( trim($name) == '' && $menuid ){
			$this->message['text'] = 'Nama menu tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		if( trim($title) == '' ){
			$this->message['text'] = 'Page title tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		if( trim(strip_tags($fulltext)) == '' ){
			$this->message['text'] = 'Content tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		
		return true;
	}
	
	function load_list(){
		$this->db->select();
		$this->db->orderby('pid');
		$r = $this->db->getwhere('pages', "slug!='welcome-message'");
		
		return $r->result();
	}
	
	function load($id=''){
		if( empty($id) ){
			$row = $this->input->post_object();
			$row->published = 'Y';
		} else {
			$this->db->select();
			$r = $this->db->getwhere('pages', "pid=$id");
			$row = $r->row();
			if( $row->menuid ){
				$this->db->select('name, published');
				$r = $this->db->getwhere('menus', "id=$row->menuid");
				$menu = $r->row();
				$row->name = $menu->name;
				$row->published = $menu->published;
			}
		}
		
		return $row;
	}
	
	function load_by_slug($slug){
		$this->db->select();
		$r = $this->db->getwhere('pages', "slug='$slug'");
		$row = $r->row();
		
		return $row;
	}
	
	function store(){
		$post['pid'] = $this->input->post('pid');
		$post['menuid'] = $this->input->post('menuid');
		$post['name'] = $this->input->post('name', true);
		$post['title'] = $this->input->post('title', true);
		$post['published'] = $this->input->post('published');
		$post['fulltext'] = $this->input->post('fulltext');
		$post['meta_keys'] = $this->input->post('meta_keys', true);
		$post['meta_desc'] = $this->input->post('meta_desc', true);
		$post['slug'] = !$this->input->post('slug', true) ? $post['title']:$this->input->post('slug');
		
		if( $post['pid'] ){
			return $this->update($post);
		} else {
			return $this->insert($post);
		}
	}
	
	function insert($post){
		$post['slug'] = url_title($post['slug']);
		$menu['name'] = $post['name'];
		$menu['published'] = $post['published'];
		unset($post['name']);
		unset($post['published']);
		$r = $this->db->insert('pages', $post);
		if( $r ){
			if( $menu['name'] != '' ){
				$pid = $this->db->insert_id();
				$menu['link'] = '/page/'.$post['slug'].'/';
				$menu['menutype'] = 'frontend';
				$menu['pagetitle'] = $post['title'];
				$menu['positionid'] = 1;
				$this->db->select('ordering');
				$this->db->orderby('ordering', 'DESC');
				$r = $this->db->getwhere('menus', "menutype='".$menu['menutype']."' AND positionid=".$menu['positionid'], 1);
				$o = $r->row();
				$menu['ordering'] = $o->ordering + 1;
				$r = $this->db->insert('menus', $menu);
				$data['menuid'] = $this->db->insert_id();			
				$sql = "UPDATE ab_pages SET menuid='$menuid' WHERE pid='$pid'";
				$r = $this->db->update('pages', $data, "pid=$pid");
			}
			
			$this->message['text'] = 'Item berhasil disimpan.';
			$this->message['class'] = 'ok';
			return true;
		} else {
			$this->message['text'] = 'Item GAGAL disimpan<br />'.$this->db->error_message();
			$this->message['class'] = 'error';
			return false;
		}
	}
	
	function update($post){
		$pid = $post['pid'];
		$post['slug'] = url_title($post['slug']);
		$menuid =  $post['menuid'];
		$menu['name'] = $post['name'];
		$menu['published'] = $post['published'];
		$menu['link'] = '/page/'.$post['slug'].'/';
		$menu['pagetitle'] = $post['title'];
		unset($post['name']);
		unset($post['published']);
		unset($post['pid']);
		unset($post['menuid']);
		
		$r = $this->db->update('pages', $post, "pid=$pid");
		if( $r ){
			if( $menuid )
				$r = $this->db->update('menus', $menu, "id=$menuid");
			
			$this->message['text'] = 'Item berhasil disimpan.';
			$this->message['class'] = 'ok';
			return true;
		} else {
			$this->message['text'] = 'Item GAGAL disimpan<br />'.$this->db->error_message();
			$this->message['class'] = 'error';
			return false;
		}
	}
	
	function published($published){
		$post = $this->input->post('id');
		foreach( $post as $key => $id ){
			$this->db->select('menuid');
			$r = $this->db->getwhere('pages', "pid=$id", 1, 0);
			$row = $r->row();
			$menuid = $row->menuid;
			
			$r = $this->db->update('menus', array('published'=>"$published"), "id=$menuid");
		}
		
		return true;
	}
	
	function delete(){
		$post = $this->input->post('id');
		$ftotal = 0;
		$stotal = 0;
		foreach( $post as $key => $id ){
			$this->db->select('menuid');
			$r = $this->db->getwhere('pages', "pid=$id", 1, 0);
			$row = $r->row();
			$menuid = $row->menuid;
			
			if( $menuid ){
				$r = $this->db->delete('menus', "id=$menuid");
				if( $r === false ){
					$ftotal++;
				} else {
					$r = $this->db->delete('pages', "pid=$id");
					$stotal++;
				}
			} else {
				$r = $this->db->delete('pages', "pid=$id");
				if( $r === false ){
					$ftotal++;
				} else {
					$stotal++;
				}
			}
		}
		
		$msg = '';
		if( $stotal > 0 ){
			$msg .= 'Berhasil menghapus '.$stotal.' data<br />';
		}
		if( $ftotal > 0 ){
			$msg .= 'Gagal menghapus '.$ftotal.' data';
		}
		
		$this->message['text'] = $msg;
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function pageadd(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button('save', 'true');
		$btn .= $this->button->separator();
		$btn .= $this->button->cancel_button('/backend/page/index/');
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function button_wm(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button('save', 'true');
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function pagelist(){
		$btn = $this->button->start();
		if( current_user_permision('write') === true ){
			$btn .= $this->button->add_button('/backend/page/add/');
			$btn .= $this->button->separator();
		}
		
		if( current_user_permision('delete') === true ){
			$btn .= $this->button->delete_button();
		}
		$btn .= $this->button->end();
		
		return $btn;
	}
}
?>