<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class User_model extends Model {	
	function User_model(){
		parent::Model();
	}
	
	function validation(){
		$username = $this->input->post('username');
		$id = $this->input->post('id');
		if( trim($username) == '' && !$id ){
			$this->message['text'] = 'Username tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		if( ereg("[^a-zA-Z0-9_.]", $username) && !$id ){
			$this->message = 'Username Anda memuat karakter yang tidak diperbolehkan. Hanya huruf, angka, underscore dan titik yang diperbolehkan untuk username.';
			$this->message['class'] = 'error';
			return false;
		}
		if( $this->check_username($username) === false && !$id ){
			$this->message['text'] = 'Username sudah digunakan. Silahkan pilih username yang lain.';
			$this->message['class'] = 'error';
			return false;
		}
		$passwd = $this->input->post('passwd');
		if( trim($passwd) == '' && !$id ){
			$this->message['text'] = 'Password tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		$repasswd = $this->input->post('repasswd');
		if( $passwd != $repasswd && !$id ){
			$this->message['text'] = 'Ulang Password tidak sama dengan password.';
			$this->message['class'] = 'error';
			return false;
		}
		$name = $this->input->post('name', true);
		if( trim($name) == '' ){
			$this->message['text'] = 'Nama tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		$email = $this->input->post('email');
		if( trim($email) == '' ){
			$this->message['text'] = 'Email tidak boleh kosong.';
			$this->message['class'] = 'error';
			return false;
		}
		if( !(preg_match("/[\w\.\-]+@\w+[\w\.\-]*?\.\w{2,4}/", $email)) ){
			$this->message['text'] = 'Email yang Anda masukan tidak valid.';
			$this->message['class'] = 'error';
			return false;
		}
		return true;
	}
	
	function store(){
		$post['id'] = $this->input->post('id');
		$post['username'] = $this->input->post('username');
		$post['passwd'] = $this->input->post('passwd');
		$post['repasswd'] = $this->input->post('repasswd');
		$post['name'] = $this->input->post('name', true);
		$post['email'] = $this->input->post('email');
		$post['status'] = $this->input->post('status');
		$post['gid'] = $this->input->post('gid');
		
		if( $post['id'] ){
			return $this->update($post);
		} else {
			return $this->insert($post);
		}
	}
	
	function insert($post){
		$data['username'] = $post['username'];
		$data['password'] = md5($post['passwd'].$this->config->item('encryption_key'));
		$data['name'] = $post['name'];
		$data['email'] = $post['email'];
		$data['status'] = @$post['status'] ? 'A':'N';
		$data['groupid'] = 1;
		$data['gid'] = $post['gid'];	
		$r = $this->db->insert('users', $data);
		if( $r === false ){
			$this->message['text'] = 'User gagal disimpan';
			$this->message['class'] = 'error';
			return false;
		}
		$this->message['text'] = 'User berhasil disimpan';
		$this->message['class'] = 'ok';
		return true;
	}
	
	function update($post){
		$id = $post['id'];
		$uid = get_session_item('user_id', 'backend');
		if( trim($post['passwd']) != '' )
			$data['password'] = md5($post['passwd'].$this->config->item('encryption_key'));
			
		$data['name'] = $post['name'];
		$data['email'] = $post['email'];
		$data['gid'] = $post['gid'];
		
		if( $uid != $id )
			$data['status'] = @$post['status'] ? 'A':'N';
		
		$r = $this->db->update('users', $data, "id=$id");
		if( $r === false ){
			$this->message['text'] = 'User gagal disimpan';
			$this->message['class'] = 'error';
			return false;
		}
		$this->message['text'] = 'User berhasil disimpan';
		$this->message['class'] = 'ok';
		return true;
	}
	
	function load_list($groupid){
		$gid = get_session_item('gid', 'backend');
		$this->db->select();
		$r = $this->db->getwhere('users', "groupid=$groupid AND gid>=$gid");
		$rows = $r->result();
		
		return $rows;
	}
	
	function load($id){
		if( empty($id) ){
			$row = $this->input->post_object();
			$row->groupid = 1;
			$row->status = 'A';
		} else {
			$this->db->select();
			$r = $this->db->getwhere('users', "id=$id");
			$row = $r->row();
		}
		
		return $row;
	}
	
	function published($published){
		$ids = $this->input->post('id');
		$uid = get_session_item('user_id', 'backend');
		foreach( $ids as $key => $id ){
			if( $id != $uid )		
				$r = $this->db->update('users', array('status'=>"$published"), "id=$id");
		}
		
		return true;
	}
	
	function delete(){
		$ids = $this->input->post('id');
		$uid = get_session_item('user_id', 'backend');
		$ftotal = 0;
		$stotal = 0;
		foreach( $ids as $key => $id ){
			if( $id != $uid ){
				$r = $this->db->delete('users', "id=$id");
				if( $r === false ){
					$ftotal++;
				} else {
					$stotal++;
				}
			}
		}
		
		$msg = '';
		if( $stotal > 0 ){
			$msg .= 'Berhasil menghapus '.$stotal.' data<br />';
		}
		if( $ftotal > 0 ){
			$msg .= 'Gagal menghapus '.$ftotal.' data';
		}
		
		$this->message['text'] = $msg;
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function check_username($username){
		$uname = trim($username);
		$this->db->select('1');
		$r = $this->db->getwhere('users', "username='$uname'");
		$e = $r->get_one();
		if( $e == 1 )
			return false;
		
		return true;
	}
	
	function load_permision_by_groupid($groupid=1){
		$this->db->select();
		$this->db->orderby('gid');
		$r = $this->db->getwhere('group_type', "groupid=$groupid");
		
		return $r->result();
	}
	
	function permision_list($groupid=1){
		$this->db->select();
		$this->db->orderby('gid');
		$r = $this->db->getwhere('group_type', "groupid=$groupid AND gid>0");
		
		return $r->result();
	}
	
	function permision_load($id){
		if( empty($id) ){
			$row['grouptype'] = $this->input->post_object();
		} else {
			$this->db->select();
			$r = $this->db->getwhere('group_type', "id=$id");
			$row['grouptype'] = $r->row();
		}
		
		$row['permisions'] = array();
		if( $row['grouptype']->id ){
			$this->db->select('menuid');
			$r = $this->db->getwhere('group_access', "groupid=".$row['grouptype']->groupid." AND gid=".$row['grouptype']->gid);
			foreach( $r->result() as $result ){
				$row['permisions'][] = $result->menuid;
			}
		}
		
		return $row;
	}
	
	function permision_validation(){
		$grouptype = $this->input->post('grouptype', true);
		if( trim($grouptype) == '' ){
			$this->message['text'] = 'Group type tidak boleh kosong';
			$this->message['class'] = 'error';
			return false;
		}
		
		return true;
	}
	
	function permision_store(){
		$post['id'] = $this->input->post('id');
		$post['groupid'] = $this->input->post('groupid');
		$post['grouptype'] = $this->input->post('grouptype', true);
		$post['menu'] = $this->input->post('menu');
		$post['read'] = $this->input->post('read');
		$post['write'] = $this->input->post('write');
		$post['delete'] = $this->input->post('delete');
		$post['modify'] = $this->input->post('modify');
		
		if( $post['id'] )
			return $this->permision_update($post);
		else
			return $this->permision_insert($post);
	}
	
	function permision_insert($post){
		$group['grouptype'] = $post['grouptype'];
		$group['groupid'] = $post['groupid'];
		$this->db->select('gid');
		$this->db->orderby('gid', 'DESC');
		$r = $this->db->getwhere('group_type', "groupid=".$group['groupid'], 1);
		$group['gid'] = $r->get_one();
		
		$r = $this->db->insert('group_type', $group);
		if( $r === false ){
			$this->message['text'] = 'Permision group gagal disimpan';
			$this->message['class'] = 'error';
			return false;
		}
		
		$this->insert_user_permision($post, $group['gid']);
		$this->message['text'] = 'Permision group berhasil disimpan';
		$this->message['class'] = 'ok';
		return true;
	}
	
	function permision_update($post){
		$group['grouptype'] = $post['grouptype'];
		$r = $this->db->update('group_type', $group, "id=".$post['id']);
		if( $r === false ){
			$this->message['text'] = 'Permision group gagal disimpan';
			$this->message['class'] = 'error';
			return false;
		}
		
		$this->db->select('gid');
		$r = $this->db->getwhere('group_type', "id=".$post['id'], 1);
		$gid = $r->get_one();
		
		$this->insert_user_permision($post, $gid);
		$this->message['text'] = 'Permision group berhasil disimpan';
		$this->message['class'] = 'ok';
		return true;
	}
	
	function insert_user_permision($post, $gid){
		$this->db->select('COUNT(menuid)');
		$r = $this->db->getwhere('group_access', "gid=$gid", 1);
		$e = $r->get_one();
		if( $e > 0 )
			$this->db->delete('group_access', "gid=$gid");
		
		foreach( $post['menu'] as $menuid ){
			$g['menuid'] = $menuid;
			$g['gid'] = $gid;
			$g['groupid'] = $post['groupid'];
			$g['write'] = $post['write'][$menuid] ? $post['write'][$menuid]:'N';
			$g['read'] = $post['read'][$menuid] ? $post['read'][$menuid]:'N';
			$g['delete'] = $post['delete'][$menuid] ? $post['delete'][$menuid]:'N';
			$g['modify'] = $post['modify'][$menuid] ? $post['modify'][$menuid]:'N';
			
			$this->db->insert('group_access', $g);
		}
	}
	
	function delete_permision(){
		$ids = $this->input->post('id');
		$ftotal = 0;
		$stotal = 0;
		foreach( $ids as $key => $id ){
			$this->db->select('gid, groupid');
			$r = $this->db->getwhere('group_type', "id=".$this->db->escape($id));
			$row = $r->row();
			$r = $this->db->delete('group_type', "id=".$this->db->escape($id));
			if( $r === false ){
				$ftotal++;
			} else {
				@$this->db->delete('group_access', "gid=".$this->db->escape($row->gid)." AND ".$this->db->escape($row->groupid));
				$stotal++;
			}
		}
		
		$msg = '';
		if( $stotal > 0 ){
			$msg .= 'Berhasil menghapus '.$stotal.' data<br />';
		}
		if( $ftotal > 0 ){
			$msg .= 'Gagal menghapus '.$ftotal.' data';
		}
		
		$this->message['text'] = $msg;
		$this->message['class'] = 'ok';
		
		return true;
	}
	
	function buttonlist($groupid){
		if( $groupid == 1 ){
			$btn = $this->button->start();
			if( current_user_permision('write') === true ){
				$btn .= $this->button->add_button('/backend/users/add/', 'Tambah User');
				$btn .= $this->button->separator();
			}
			if( current_user_permision('modify') === true ){
				$btn .= $this->button->published_button();
				$btn .= $this->button->separator();
				$btn .= $this->button->unpublished_button();
				$btn .= $this->button->separator();
			}
			if( current_user_permision('delete') === true ){
				$btn .= $this->button->delete_button();
			}
			$btn .= $this->button->end();
		}
		
		return $btn;
	}
	
	function buttonadd(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button('save', 'false');
		$btn .= $this->button->separator();
		$btn .= $this->button->cancel_button('/backend/users/account/');
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function buttonpermisionlist(){
		$btn = $this->button->start();
		if( current_user_permision('write') === true ){
			$btn .= $this->button->add_button('/backend/users/permision_add/', 'Tambah Group');
			$btn .= $this->button->separator();
		}
		if( current_user_permision('delete') === true ){
			$btn .= $this->button->delete_button();
		}
		$btn .= $this->button->end();
		
		return $btn;
	}
	
	function buttonpermisionadd(){
		$btn = $this->button->start();
		$btn .= $this->button->save_button('save', 'false');
		$btn .= $this->button->separator();
		$btn .= $this->button->cancel_button('/backend/users/permision/');
		$btn .= $this->button->end();
		
		return $btn;
	}
}
?>