<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Users extends Controller {
	function Users() {
		parent::Controller();
		$this->_check_session('backend');
		$this->load->model('User_model', 'model');
	}
	
	function index(){
		$this->account();
	}
	
	function account(){
		if( current_user_permision('read', '/backend/users/index/') === false )
			noauth();
		
		if( $this->input->post('task') == 'published' ){
			$this->model->published('A');
			redirect('/backend/users/account/', 'refresh');
		}
		if( $this->input->post('task') == 'unpublished' ){
			$this->model->published('N');
			redirect('/backend/users/account/', 'refresh');
		}
		if( $this->input->post('task') == 'delete' ){
			$this->model->delete();
			$msg = $this->model->_get_message();
			$this->session->set_userdata(array('message'=>$msg));
			redirect('/backend/users/account/', 'refresh');
		}
		
		$r['rows'] = $this->model->load_list(1);
		
		$data['page_title'] = $this->menu->get_page_title('/backend/users/index/', 'backend');
		$data['button'] = $this->model->buttonlist(1);
		$data['message'] = $this->session->userdata('message');
		$this->session->unset_userdata('message');
		$data['html'] = $this->load->cview('accountlist', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function add(){
		if( current_user_permision('write', '/backend/users/index/') === false )
			noauth();
		
		$this->edit();
	}
	
	function edit($id=''){
		if( current_user_permision('modify', '/backend/users/index/') === false && $id ){
			noauth();
		}
		if( $this->input->post('task') == 'save' ){
			if( $this->model->validation( ) === false ){
				$data['message'] = $this->model->_get_message();
			} 
			elseif( $this->model->store() === false ){
				$data['message'] = $this->model->_get_message();
			} 
			else {
				$msg = $this->model->_get_message();
				$this->session->set_userdata(array('message'=>$msg));
				redirect('/backend/users/account/', 'refresh');
			}
		}
		
		$r['row'] = $this->model->load($id);
		$r['permisions'] = $this->model->load_permision_by_groupid();
		$data['page_title'] = $this->menu->get_page_title('/backend/users/index/', 'backend').($id ? ' :: Edit User':' :: Tambah User');
		$data['button'] = $this->model->buttonadd();
		$data['html'] = $this->load->cview('accountadd', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function permision(){
		if( current_user_permision('read') === false )
			noauth();
		
		$data['message'] = $this->session->userdata('message');
		$this->session->unset_userdata('message');
		
		if( $this->input->post('task') == 'delete' ){
			$this->model->delete_permision();
			$data['message'] = $this->model->_get_message();
		}
		
		$r['rows'] = $this->model->permision_list();
		$data['page_title'] = $this->menu->get_page_title('', 'backend');
		$data['button'] = $this->model->buttonpermisionlist();
		
		$data['html'] = $this->load->cview('permision-list', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
	
	function permision_add(){
		if( current_user_permision('write', '/backend/users/permision/') === false )
			noauth();
		
		$this->permision_edit();
	}
	
	function permision_edit($id=''){
		if( current_user_permision('modify', '/backend/users/permision/') === false && $id )
			noauth();
		
		if( $this->input->post('task') == 'save' ){
			if( $this->model->permision_validation() === false ){
				$data['message'] = $this->model->_get_message();
			} 
			elseif( $this->model->permision_store() === false ){
				$data['message'] = $this->model->_get_message();
			} 
			else {
				$msg = $this->model->_get_message();
				$this->session->set_userdata(array('message'=>$msg));
				redirect('/backend/users/permision/');
			}
		}
		
		$this->load->model('Menu_model', 'menub', 'menumgr/backend');
		$r['menus'] = $this->menub->loadall('backend');
		$r['row'] = $this->model->permision_load($id);
		$r['groupid'] = 1;
		
		$data['page_title'] = $this->menu->get_page_title('/backend/users/permision/').(@$id ? ' :: Edit':' :: Tambah');
		$data['button'] = $this->model->buttonpermisionadd();
		$data['html'] = $this->load->cview('permision-add', $r, true);
		$this->load->view($this->template->get('dir', 'backend').'layout', $data);
	}
}
?>