<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

function get_kategori($parentid=0, $withproduct=false, $limit=10){
	$obj =& get_instance();
	
	$obj->db->select();
	$obj->db->orderby('ordering', 'ASC');
	$r = $obj->db->getwhere('product_categories', "published='Y' AND parentid=$parentid");
	if( $r === false )
		return array();
	
	$rows = array();
	foreach( $r->result() as $row ){
		$row->subcat = get_kategori($row->id);
		if( $withproduct === true ){
			$row->products = get_product_by_category($row->id, 'name, id', $limit);
		}
		$rows[] = $row;
	}
	
	return $rows;
}

function get_product_by_category($catid, $select='*', $limit=''){
	$obj =& get_instance();
	
	$obj->db->select($select);
	$r = $obj->db->getwhere("products", "catid=$catid", $limit);
	$rows = $r->result();
	
	return $rows;
}

function get_product($select='*', $limit=10, $orderby='createddate', $ordertype='DESC'){
	$obj =& get_instance();
	
	$obj->db->select($select);
	$obj->db->orderby($orderby, $ordertype);
	$r = $obj->db->get("products", $limit);
	$rows = $r->result();
	
	return $rows;
}

function get_random_product($select='*', $limit=1){
	$obj =& get_instance();
	
	$obj->db->select('COUNT(id)');
	$r = $obj->db->get('products', 1);
	$total = $r->get_one();
	
	$rand = rand(0, $total - 1);
	
	$obj->db->select($select);
	$r = $obj->db->get('products', 1, $rand);
	
	return $r->row();
}

function get_category_name($catid){
	$obj =& get_instance();
	
	$obj->db->select('name');
	$r = $obj->db->getwhere('product_categories', "id=$catid", 1);
	
	return $r->get_one();
}

function format_uang($str){
	return number_format($str, 2, ',', '.');
}
?>