<?php
class Ordering {
	var $tbl_key = 'id';
	var $where = array();
	var $table = '';
	var $limit_start = 0;
	var $numrows;
	
	function Ordering(){
		$this->obj =& get_instance();
	}
	
	function initialize($config){
		if( !is_array($config) ){
			return false;
		}
		
		foreach( $config as $key => $val ){
			$method = 'set_'.$key;
			if (method_exists($this, $method)){
				$this->$method($val);
			}
			else
			{
				$this->$key = $val;
			}	
		}
	}
	
	function set_table($table){
		$this->table = $table;
	}
	
	function set_table_key($key='id'){
		$this->tbl_key = $key;
	}
	
	function set_where($key, $value){
		$this->where[$key] = $value;
	}
	
	function set_limit_start($limit_start=0){
		$this->limit_start = $limit_start;
	}
	
	function set_numrows($numrows){
		$this->numrows = intval($numrows);
	}
	
	function order_up($id){
		$this->_ordering(-1, $id);
	}
	
	function order_down($id){
		$this->_ordering(1, $id);
	}
	
	function _ordering($inc, $id){
		$k = $this->tbl_key;
		$this->obj->db->select("$k, ordering");
		$r = $this->obj->db->getwhere($this->table, "$this->tbl_key='$id'");
		$o = $r->row();
		$cur_order = $o->ordering;
		$cur_id = $o->$k;
		
		$this->obj->db->select("$k, ordering");
		if( $inc < 0 ){
			$this->obj->db->where("ordering <", $cur_order);
			$this->obj->db->where($this->where);
			$this->obj->db->orderby("ordering", "DESC");
		} else if ($inc > 0) {
			$this->obj->db->where("ordering >", $cur_order);
			$this->obj->db->where($this->where);
			$this->obj->db->orderby("ordering", "ASC");
		} else {
			$this->obj->db->where("ordering", $cur_order);
			$this->obj->db->where($this->where);
			$this->obj->db->orderby("ordering", "ASC");
		}
		
		$r = $this->obj->db->get($this->table, 1);
		if( $r ){
			$row = $r->row();
			$data['ordering'] = $row->ordering;
			$this->obj->db->update($this->table, $data, "$k=$cur_id");
			
			$data['ordering'] = $cur_order;
			$this->obj->db->update($this->table, $data, "$k=".$row->$k);
		}
	}
	
	function order_up_icon($i, $condition=true){
		if( ($i > 0 || ($i + $this->limit_start > 0)) && $condition ){
			$html = '<a href="#orderup" onclick="checkItem(\'cb'.$i.'\'); submit_form(\'orderup\');"><img src="'.$this->obj->template->get('full_url', 'backend').'images/order_up.gif" border="0" alt="" /></a>';
		} else {
			$html = '&nbsp;';
		}
		
		return $html;
	}
	
	function order_down_icon($i, $n, $condition=true){
		if( ($i < $n-1 || ($i + $this->limit_start < $this->numrows)) && $condition ){
			$html = '<a href="#orderdown" onclick="checkItem(\'cb'.$i.'\'); submit_form(\'orderdown\');"><img src="'.$this->obj->template->get('full_url', 'backend').'images/order_down.gif" border="0" alt="" /></a>';
		} else {
			$html = '&nbsp;';
		}
		
		return $html;
	}
}
?>